;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;    MASK FOR BASELINES
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;

sdc345p0_mask_str = sdc345p0_58023_str

sdc345p0_mask_str.image = sdc345p0_58023_str.image*0.
ind_mask = where(median(sdc345p0_58023_str.image,10) gt 1.5)
sdc345p0_mask_str.image(ind_mask) = 1.

;mask_center = sdc345p0_mask_str.image*0.
;mask_center(471:679,276:664) = 1.

ind_edge = where(sdc345p0_58023_str.weight lt 2.1)
;ind_edge = where(sdc345p0_58023_str.image gt 1.5 and sdc345p0_58023_str.weight lt 2)

mask_edge = sdc345p0_mask_str.image*0.
mask_edge(ind_edge) = 1.

sdc345p0_mask_str.image = sdc345p0_mask_str.image*(1.-mask_edge)
;sdc345p0_mask_str.image = sdc345p0_mask_str.image*mask_center

masque_str = sdc345p0_mask_str
save, filename = work_dir+'apexdata/map_otf_fits/sdc345p0_mask_str.xdr', masque_str

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;

sdc345p0_mask_str = sdc345p0_comb_m_tmp_str

sdc345p0_mask_str.image = sdc345p0_comb_m_tmp_str.image*0.
ind_mask = where(sdc345p0_comb_m_tmp_str.image gt 2.)
sdc345p0_mask_str.image(ind_mask) = 1.

ind_edge = where(sdc345p0_comb_m_tmp_str.image gt 2. and sdc345p0_comb_m_tmp_str.weight lt 30)

mask_edge = sdc345p0_mask_str.image*0.
mask_edge(ind_edge) = 1.

mask_edge(271:531,1884:2076) = 0
mask_edge(907:1171,2328:2552) = 0
mask_edge(1467:2123,448:968) = 0

sdc345p0_mask_str.image = sdc345p0_mask_str.image*(1.-mask_edge)

masque_str = sdc345p0_mask_str
save, filename = work_dir+'apexdata/map_otf_fits/sdc345p0_mask_m_tmp_str.xdr', masque_str





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;

sdc345p0_comb_str = sdc345p0_comb_15_16jul_str

sdc345p0_mask2_str = sdc345p0_comb_str

sdc345p0_mask2_str.image = sdc345p0_comb_str.image*0.
ind_mask2 = where(sdc345p0_comb_str.image gt 2.)
sdc345p0_mask2_str.image(ind_mask2) = 1.

mask2_center = sdc345p0_mask2_str.image*0.
mask2_center(386:1138,495:1407) = 1.

mask2_wsource = sdc345p0_mask2_str.image*0.
mask2_wsource(1091:1197,278:366) = 1.

ind_edge = where(sdc345p0_comb_str.image gt 2. and sdc345p0_comb_str.weight lt 30 and mask2_center eq 0. and mask2_wsource eq 0.)

mask2_edge = mask2_center*0.
mask2_edge(ind_edge) = 1.

sdc345p0_mask2_str.image = sdc345p0_mask2_str.image*(1.-mask2_edge)

masque_str = sdc345p0_mask2_str
save, filename = work_dir+'apexdata/map_otf_fits/sdc345p0_mask2_str.xdr', masque_str

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;



oria_herschel_350 = readfits('../../apex_2013/oriona_herschel_350.fits',hdr_oria_herschel_350)

oria_herschel_mask = oria_herschel_350*0.
ind_mask = where(oria_herschel_350 gt 38.)
oria_herschel_mask(ind_mask) = 1.

sdc345p0_mask = oria_herschel_350*0.
sdc345p0_mask(1411:1471,2041:2116) = 1.

ind_nan_irc2 = where(finite(oria_herschel_350,/NaN) and sdc345p0 _mask eq 1)
oria_herschel_mask(ind_nan_irc2) = 1.

oria_herschel_masque_str = {name:'Ori A at 350 microns - Herschel',image:oria_herschel_mask, weight:oria_herschel_mask*0.+1.,crpix1:1138.0-1.d0, crpix2:1371.0-1.d0, $
  alpha_ref:84.66702102334555d0, delta_ref:-7.348192623018265d0, cdelt1:-0.002777777777778d0, cdelt2:0.002777777777777778d0, $
	              source:'ORI-A'}
;

masque_str = oria_herschel_masque_str
save, filename = work_dir+'apexdata/map_otf_fits/oria_herschel_mask_str.xdr', masque_str


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;    GAUSSIAN MODEL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
restore, work_dir+'apexdata/map_otf_fits/b59_mask_str.xdr', /verb 
;
; 298.5, 96    --> B59-MMS3
; 289, 173     --> B59-MMS1
; 296, 136     --> B59-MMS2

restore, 'b59_comb_all.xdr', /verb  ;  <-- b59_comb_all_str centered on B59-MMS2

; crpix1 = 109.20485, crpix2 = 104.86456  --> B59-MMS2

masque_str = b59_comb_all_str

taille = size(masque_str.image)
COMMON SHARE_GRID, XDimc, YDimc, XRefc, YRefc, XValc, YValc, Xincc, Yincc
Xdim = taille(1)
Ydim = taille(2)
xrefc = (Xdim-1)/2.
yrefc = (Ydim-1)/2.
;
;xref = 298.5
;yref = 96.
;
;xref = 289.
;yref = 173.
;
;xref = 296.
;yref = 136.

xref = 109.20485
yref = 104.86456

;.
xval = 0.
yval = 0.
xinc = masque_str.cdelt1*3600.		;  pixel in arcsec
yinc = masque_str.cdelt2*3600.
fwhm = 15.  ;  240.;  120.;  30.  ; 20.				; arcsec
;
gauss0 = fltarr(Xdim,Ydim)
xarray = fltarr(Xdim,Ydim)
yarray = fltarr(Xdim,Ydim)
arg_exp = fltarr(Xdim,Ydim)
linx = findgen(Xdim)
liny = findgen(Ydim)
for j = 0,Ydim-1 do xarray(*,j) = linx
for i = 0,Xdim-1 do yarray(i,*) = liny
xarray = (xarray - xref)*xinc + xval
yarray = (yarray - yref)*yinc + yval
Rarray = sqrt(xarray^2 + yarray^2)
R2array = xarray^2 + yarray^2
arg_exp = 4.*alog(2.)*R2array/fwhm^2
gauss0(where(arg_exp le 86.)) = exp(-arg_exp(where(arg_exp le 86.)))
xarray = 0.
yarray = 0.
Rarray = 0.
arg_exp = 0.
;
model_gauss_str = masque_str
model_gauss_str.image = gauss0
;
model_str = masque_str
model_str.image = gauss0
image = model_str.image
image_conv = p_conv_gauss(image,120.)
;
model_back_str = masque_str
model_back_str.image = image_conv
;
;save, filename = work_dir+'apexdata/map_otf_fits/b59mms3_test_gauss.xdr', model_gauss_str
;save, filename = work_dir+'apexdata/map_otf_fits/b59mms1_test_gauss.xdr', model_gauss_str
save, filename = work_dir+'apexdata/map_otf_fits/b59mms2_test_gauss.xdr', model_str




traite_otf_map_model,scan_number=44517,model='b59mms2_test_gauss.xdr',type='decorrel',b59mms2_mod_spiral_44517,champ_base='b59_mask_str.xdr', /med_noise_rem, /med_base, /do_rcp

traite_otf_map_model,scan_number=44517,model='b59mms2_test_gauss.xdr',type='decorrel',b59mms2_mod_spiral_44517,champ_base='b59_mask_str.xdr',/med_noise_rem,/med_base,/do_rcp,rms_uncorr=20.,rms_corr=100.

traite_otf_map_model,scan_number=44517,model='b59mms2_test_gauss.xdr',type='decorrel',b59mms2_mod_spiral_44517,champ_base='b59_mask_str.xdr', med_noise_rem=10, /do_rcp,rms_uncorr=20.,rms_corr=100.
traite_otf_map_model,scan_number=44517,model='b59mms2_test_gauss.xdr',type='decorrel',b59mms2_mod_spiral_44517_2,champ_base='b59_mask2_str.xdr', med_noise_rem=10, /med_base, /do_rcp,rms_uncorr=20.,rms_corr=100.

traite_otf_map_model,scan_number=44517,model='b59mms2_test_gauss.xdr',type='decorrel',rmode='filt_sp',b59mms2_mod_spiral_44517,champ_base='b59_mask_str.xdr',/med_noise_rem,/med_base,/do_rcp,rms_uncorr=20.,rms_corr=100.

traite_otf_map_model,scan_number=44517,model='b59mms2_test_gauss.xdr',type='decorrel',rmode='filt_sp',b59mms2_mod_spiral_44517_uncorr,champ_base='b59_mask_str.xdr',/med_noise_rem,/med_base,/do_rcp,rms_uncorr=100.,rms_corr=100.


traite_otf_map_model,scan_number=44517,model='b59mms2_test_gauss.xdr',type='decorrel',b59mms2_mod_spiral_44517_2_row,champ_base='b59_mask2_str.xdr', med_noise_rem=10,/med_base,/do_rcp,rms_uncorr=20.,rms_corr=20.


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;    TESTS/FOURIER ANALYSIS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
restore, work_dir+'apexdata/map_otf_xdr/E-083.C-0996A-2009/otf_subscan_mod_44517_13.xdr', /verb
donnees_simu = donnees
donnees_red_simu = donnees_red
wset, 0
plot, donnees.lst-donnees.lst(0), donnees_simu.cube(7,7,*), /ynozero
plot, donnees.lst-donnees.lst(0), donnees_red_simu.cube(7,7,*)

restore, work_dir+'apexdata/map_otf_xdr/E-083.C-0996A-2009/otf_subscan_44517_13.xdr', /verb			;  Tests ras_spiral25b (60s x 25 subscans) centered on B59-MMS2

init_obs, scan_number=44517, type='map', init_obs_str
dx_rcp = init_obs_str.dx_rcp
dy_rcp = init_obs_str.dy_rcp

donnees_mod = make_model_data(donnees_red,model_str)
donnees_mod = make_model_data(donnees_red,model_str,dx_rcp=init_obs_str.dx_rcp, dy_rcp=init_obs_str.dy_rcp)

donnees_back = make_model_data(donnees_red,model_back_str,dx_rcp=init_obs_str.dx_rcp, dy_rcp=init_obs_str.dy_rcp)

noise_fft_pro, donnees_mod, goodpix_ima, mean_level, mean_level_av, rms_noise, rms_noise_av, cube_pow_spec, pow_spec_av
noise_fft_pro, donnees_back, goodpix_ima, mean_level, mean_level_av, rms_noise, rms_noise_av, cube_back_pow_spec, back_pow_spec_av
wset, 1
plot, donnees.lst-donnees.lst(0), donnees_mod.cube(7,7,*)
plot, donnees.lst-donnees.lst(0), donnees_back.cube(7,7,*)

wset, 20
back_pow_max = max(back_pow_spec_av(0:ndim/2))
plot, frequency, back_pow_spec_av(0:ndim/2), xtitle="Frequency (Hz)", $
ytitle="Relative amplitude", title="Mean back_power spectrum over valid pixels", $
xrange=[0,0.35], yrange=[-0.1*back_pow_max/sqrt(2.),back_pow_max*1.05], /XSTYLE

pow_max = max(pow_spec_av(0:ndim/2))
plot, frequency, pow_spec_av(0:ndim/2), xtitle="Frequency (Hz)", $
ytitle="Relative amplitude", title="Mean power spectrum over valid pixels", $
xrange=[0,3.], yrange=[-0.1*pow_max/sqrt(2.),pow_max*1.05], /XSTYLE

xrange=[0,0.35], yrange=[-0.1*pow_max/sqrt(2.),pow_max*1.05], /XSTYLE

plot, frequency, cube_pow_spec(7,7,0:ndim/2), xtitle="Frequency (Hz)", $
plot, frequency, cube_pow_spec(2,2,0:ndim/2), xtitle="Frequency (Hz)", $
ytitle="Relative amplitude", title="Power spectrum", $
xrange=[0,3], yrange=[-0.1*pow_max/sqrt(2.),pow_max*1.05], /XSTYLE


filter_spiral, donnees_mod, donnees_mod_filtered, rms_noise, rms_noise_filtered
noise_fft_pro, donnees_mod_filtered, goodpix_ima, mean_level, mean_level_av, rms_noise, rms_noise_av, cube_pow_spec_filt, pow_spec_av_filt

cube = donnees_mod_filtered.cube
med_baseline_scan, cube, cube_base, rms_noise
donnees_med_base = donnees_mod
donnees_med_base.cube = cube_base

median_decorrel_scan, donnees_mod, donnees_mod_decorrel, correlation_matrice

wset, 0
plot, donnees.lst-donnees.lst(0), donnees_mod_filtered.cube(7,7,*)
plot, donnees.lst-donnees.lst(0), donnees_med_base.cube(7,7,*)
plot, donnees.lst-donnees.lst(0), donnees_mod_decorrel.cube(7,7,*)

wset, 21
plot, frequency, pow_spec_av_filt(0:ndim/2), xtitle="Frequency (Hz)", $
ytitle="Relative amplitude", title="Mean power spectrum over valid pixels", $
xrange=[0,3.], yrange=[-0.1*pow_max/sqrt(2.),pow_max*1.05], /XSTYLE

restore, work_dir+'apexdata/map_otf_fits/' + 'b59_mask_str.xdr', /verb
masque_base_str = masque_str
cube_masque = locate_signal(donnees, masque_base_str)
median_decorrel_scan, donnees_mod, donnees_mod_decorrel, correlation_matrice, cube_masque = cube_masque

cube_mod = donnees_mod.cube
med_baseline_scan, cube_mod, cube_mod_base, rms_noise, cube_masque = cube_masque
baseline_scan, cube_mod, cube_masque, cube_mod_base, rms_noise

donnees_mod_base = donnees_mod
donnees_mod_base.cube = cube_mod_base

wset, 20
plot, donnees.lst-donnees.lst(0), donnees_mod_decorrel.cube(7,7,*)
plot, donnees.lst-donnees.lst(0), donnees_mod_base.cube(7,7,*)

echant = 3
do_map_scan, donnees_mod, positions, out_ima_dim, echant=echant, carte_scan_mod
do_map_scan, donnees_mod, positions, out_ima_dim, echant=echant, dx_rcp=dx_rcp, dy_rcp=dy_rcp, /do_rcp, carte_scan_mod
do_map_scan, donnees_back, positions, out_ima_dim, echant=echant, dx_rcp=dx_rcp, dy_rcp=dy_rcp, /do_rcp, carte_scan_back

do_map_scan, donnees_mod_filtered, positions, out_ima_dim, echant=echant, dx_rcp=dx_rcp, dy_rcp=dy_rcp, /do_rcp, carte_scan_mod_filtered

do_map_scan, donnees_mod_decorrel, positions, out_ima_dim, echant=echant, dx_rcp=dx_rcp, dy_rcp=dy_rcp, /do_rcp, carte_scan_mod_decorrel

do_map_scan, donnees_mod_base, positions, out_ima_dim, echant=echant, dx_rcp=dx_rcp, dy_rcp=dy_rcp, /do_rcp, carte_scan_mod_base


do_map_scan, donnees_simu, positions, out_ima_dim, echant=echant, dx_rcp=dx_rcp, dy_rcp=dy_rcp, /do_rcp, carte_scan_simu
do_map_scan, donnees_red_simu, positions, out_ima_dim, echant=echant, dx_rcp=dx_rcp, dy_rcp=dy_rcp, /do_rcp, carte_scan_red_simu
;
;
restore, work_dir+'apexdata/map_otf_xdr/E-083.C-0996A-2009/otf_subscan_44529_13.xdr', /verb			;  Tests ras_spiral25b (60s x 25 subscans) centered on B59-MMS3
donnees_mod20 = make_model_data(donnees,model_gauss_str)
donnees_mod30 = make_model_data(donnees,model_gauss_str)
;
restore, work_dir+'apexdata/map_otf_xdr/E-083.C-0996A-2009/otf_subscan_44528_1.xdr', /verb			;  Tests a_spirallras  (4*35s in continuous mode) centered on B59-MMS1
donnees_mod30 = make_model_data(donnees,model_gauss_str)
;
;
;
traite_otf_map_model,scan_number=24929,model='b59mms2_test_gauss.xdr',type='decorrel',b59mms2_mod_otf_24929, champ_base='b59_mask_str.xdr', /med_noise_rem, /med_base, /do_rcp

restore, work_dir+'apexdata/map_otf_xdr/E-083.C-0996A-2009/otf_subscan_24929_31.xdr', /verb			;  Tests otf  (120"x120" @ 8"/sec; 2" cross-scan step) centered on B59-MMS2

donnees_mod = make_model_data(donnees_red,model_str)
wset, 1
plot, donnees.lst-donnees.lst(0), donnees_mod.cube(7,7,*)

init_obs, scan_number=24929, type='map', init_obs_str
dx_rcp = init_obs_str.dx_rcp
dy_rcp = init_obs_str.dy_rcp
echant = 3
do_map_scan, donnees_mod, positions, out_ima_dim, echant=echant, dx_rcp=dx_rcp, dy_rcp=dy_rcp, /do_rcp, carte_scan_mod

do_map_scan, donnees_mod, positions, out_ima_dim, echant=echant, carte_scan_mod 

do_map_scan, donnees_simu, positions, out_ima_dim, echant=echant, carte_scan_simu

for i = 0, 599 do atv, donnees_mod.cube(*,*,i)


donnees_mod30 = make_model_data(donnees,model_gauss_str)
;
wset, 21
plot, donnees.lst-donnees.lst(0), donnees_mod20.cube(8,8,*)
plot, donnees.lst-donnees.lst(0), donnees_mod30.cube(8,8,*)
;
kill_high, donnees_red, donnees_red_filthigh, rms_noise, rms_noise_filthigh

;
goodpix_ima = donnees.goodpix_ima
;
noise_fft_pro, donnees_mod20, goodpix_ima, mean_level, mean_level_av, rms_noise, rms_noise_av, cube_pow_spec20, pow_spec_av20
noise_fft_pro, donnees_mod, goodpix_ima, mean_level, mean_level_av, rms_noise, rms_noise_av, cube_pow_spec, pow_spec_av

taille = size(donnees.cube)
ndim = taille(3)
lst = donnees.lst
lst0 = lst(0:ndim-2)
lst1 = lst(1:ndim-1)

dt = dlst2dtloc(median(lst1-lst0))
print, "Sampling time (sec) :", dt 
  
time = findgen(ndim)*dt		; timeline in sec
sfint = 1./(ndim*dt)		; smallest non-zero positive frequency in Hz
frequency = findgen(1+ndim/2)*sfint
freqmax = 1./(2.*dt)		; Nyquist frequency (highest frequency that
;					; can be sampled)

wset, 20
pow_max = max(pow_spec_av(0:ndim/2))
plot, frequency, pow_spec_av(0:ndim/2), xtitle="Frequency (Hz)", $
ytitle="Relative amplitude", title="Mean power spectrum over valid pixels", $
xrange=[0,3], yrange=[-0.1*pow_max/sqrt(2.),pow_max*1.05], /XSTYLE

o
plot, frequency, pow_spec_av_filt(0:ndim/2), xtitle="Frequency (Hz)", $
ytitle="Relative amplitude", title="Mean power spectrum over valid pixels", $
xrange=[0,3], yrange=[-0.1*pow_max/sqrt(2.),pow_max*1.05], /XSTYLE

pow_max20 = max(pow_spec_av20(0:ndim/2))
plot, frequency, pow_spec_av20(0:ndim/2), xtitle="Frequency (Hz)", $
ytitle="Relative amplitude", title="Mean power spectrum over valid pixels", $
xrange=[0,3], yrange=[-0.1*pow_max20/sqrt(2.),pow_max20*1.05], /XSTYLE

plot, frequency, cube_pow_spec20(9,9,0:ndim/2), xtitle="Frequency (Hz)", $
ytitle="Relative amplitude", title="Power spectrum", $
xrange=[0,3], yrange=[-0.1*pow_max20/sqrt(2.),pow_max20*1.05], /XSTYLE

noise_fft_pro, donnees_mod30, goodpix_ima, mean_level, mean_level_av, rms_noise, rms_noise_av, cube_pow_spec30, pow_spec_av30

pow_max30 = max(pow_spec_av30(0:ndim/2))
plot, frequency, pow_spec_av30(0:ndim/2), xtitle="Frequency (Hz)", $
ytitle="Relative amplitude", title="Mean power spectrum over valid pixels", $
xrange=[0,3], yrange=[-0.1*pow_max30/sqrt(2.),pow_max30*1.05], /XSTYLE
;xrange=[0,1], yrange=[-0.1*pow_max30/sqrt(2.),pow_max30*1.05], /XSTYLE

plot, frequency, cube_pow_spec30(7,7,0:ndim/2), xtitle="Frequency (Hz)", $
ytitle="Relative amplitude", title="Power spectrum", $
xrange=[0,3], yrange=[-0.1*pow_max30/sqrt(2.),pow_max30*1.05], /XSTYLE

filter_spiral, donnees_mod30, donnees_mod30_filtered, rms_noise, rms_noise_filtered
;
noise_fft_pro, donnees_mod30_filtered, goodpix_ima, mean_level, mean_level_av, rms_noise, rms_noise_av, cube_pow_spec30_filt, pow_spec_av30_filt

plot, frequency, pow_spec_av30_filt(0:ndim/2), xtitle="Frequency (Hz)", $
ytitle="Relative amplitude", title="Mean power spectrum over valid pixels", $
xrange=[0,1], yrange=[-0.1*pow_max30/sqrt(2.),pow_max30*1.05], /XSTYLE

;
;

noise_fft_pro, donnees_red, goodpix_ima, mean_level, mean_level_av, rms_noise, rms_noise_av, cube_pow_spec, pow_spec_av
noise_fft_pro, donnees_filtered, goodpix_ima, mean_level, mean_level_av, rms_noise, rms_noise_av, cube_pow_spec, pow_spec_av
noise_fft_pro, donnees_red_filthigh, goodpix_ima, mean_level, mean_level_av, rms_noise, rms_noise_av, cube_pow_spec_filthigh, pow_spec_av_filthigh

pow_max = max(pow_spec_av(0:ndim/2))
plot, frequency, pow_spec_av(0:ndim/2), xtitle="Frequency (Hz)", $
ytitle="Relative amplitude", title="Mean power spectrum over valid pixels", $
xrange=[0,3], yrange=[-0.1*pow_max/sqrt(2.),pow_max*1.05], /XSTYLE

plot, frequency, cube_pow_spec(8,8,0:ndim/2), xtitle="Frequency (Hz)", $
ytitle="Relative amplitude", title="Power spectrum", $
xrange=[0,3], yrange=[-0.1*pow_max/sqrt(2.),pow_max*1.05], /XSTYLE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;    MODELS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
image = b59_comb_str.image*0.
weight_max = max(b59_comb_str.weight)
ind = where(b59_comb_str.weight gt 0.03*weight_max and b59_comb_str.image gt 0.5)
image(ind) = b59_comb_str.image(ind)
mask = image*0.
mask(168:188,209:266) = 1.
image = image*mask
image(168:169,250:253) = 0.
image(178,247)=0.

;
model_str = b59_comb_str
model_str.image = image
save, filename = '/mnt/data2/pandre/partemis/apexdata/map_otf_fits/b59_model_str.xdr', model_str

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

image = b59mms2_spiral_44517_filt_row.image*0.
weight_max = max(b59mms2_spiral_44517_filt_row.weight)

ind = where(b59mms2_spiral_44517_filt_row.weight gt 0.5*weight_max and b59mms2_spiral_44517_filt_row.image gt 0.9)

image(ind) = b59mms2_spiral_44517_filt_row.image(ind)

model_str = b59mms2_spiral_44517_filt_row
model_str.image = image
save, filename = work_dir + 'apexdata/map_otf_fits/b59mms2_44517_model_str.xdr', model_str
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

