; neptune.pro: "Batch" IDL file 
;
;

scan_neptune_25010 = [25010, 25011, 25012, 25013, 25014, 25015, 25016, 25017]
traite_nodding_apex, scan_neptune_25010, neptune_25010, rms, cube_nodding, nodding, tau = 0.5, mean_lst = mean_lst, image_nod=image_nod, pwv=pwv

init_obs, scan_number= 25230, type = 'map', init_obs_25230_str

traite_otf_map_main, scan_number= 25230, type = 'decorrel', neptune_spiral_25230_str, tau=0.66,/do_rcp

neptune_25230_str = neptune_spiral_25230_str
wei_max = max(neptune_spiral_25230_str.weight)
ind = where(neptune_25230_str.weight lt 0.15*wei_max)
neptune_25230_str.image(ind) = 0.

neptune_25230_gaussfit = gauss2dfit(neptune_25230_str.image,neptune_25230_gaussfit_aparm,/tilt)

print, "Zero Level (Jy/beam) = ", neptune_25230_gaussfit_aparm(0)
print, "Peak Intensity (Jy/beam) = ", neptune_25230_gaussfit_aparm(1)
print, "Delta x  (arcsec) = ", (neptune_25230_gaussfit_aparm(4)-neptune_25230_str.crpix1)*neptune_25230_str.cdelt1*3600.
print, "Delta y  (arcsec) = ", (neptune_25230_gaussfit_aparm(5)-neptune_25230_str.crpix2)*neptune_25230_str.cdelt2*3600.
print, "Position angle of major axis measured counterclockwise from x axis (deg) = ", neptune_25230_gaussfit_aparm(6)
print, "Maj FWHM (arcsec) = ", neptune_25230_gaussfit_aparm(2)*sqrt(8.*alog(2.))*neptune_25230_str.cdelt2*3600.
print, "Min FWHM (arcsec) = ", neptune_25230_gaussfit_aparm(3)*sqrt(8.*alog(2.))*neptune_25230_str.cdelt2*3600.


init_obs, scan_number= 25375, type = 'map', init_obs_25375_str

traite_otf_map_main, scan_number= 25375, type = 'decorrel', neptune_spiral_25375_str, tau=0.85,/do_rcp

make_fits, neptune_spiral_25375_str

restore, '/Users/pandre/kosma/artemis/apexdata/map_otf_xdr/E-083.C-0996A-2009/otf_subscan_25375_1.xdr', /verb
make_fits, carte_scan, fileout='neptune_spiral_25375_xy', /xy


neptune_25375_str = neptune_spiral_25375_str
wei_max = max(neptune_spiral_25375_str.weight)
ind = where(neptune_25375_str.weight lt 0.15*wei_max)
neptune_25375_str.image(ind) = 0.

neptune_25375_gaussfit = gauss2dfit(neptune_25375_str.image,neptune_25375_gaussfit_aparm,/tilt)

print, "Zero Level (Jy/beam) = ", neptune_25375_gaussfit_aparm(0)
print, "Peak Intensity (Jy/beam) = ", neptune_25375_gaussfit_aparm(1)
print, "Delta x  (arcsec) = ", (neptune_25375_gaussfit_aparm(4)-neptune_25375_str.crpix1)*neptune_25375_str.cdelt1*3600.
print, "Delta y  (arcsec) = ", (neptune_25375_gaussfit_aparm(5)-neptune_25375_str.crpix2)*neptune_25375_str.cdelt2*3600.
print, "Position angle of major axis measured counterclockwise from x axis (deg) = ", neptune_25375_gaussfit_aparm(6)
print, "Maj FWHM (arcsec) = ", neptune_25375_gaussfit_aparm(2)*sqrt(8.*alog(2.))*neptune_25375_str.cdelt2*3600.
print, "Min FWHM (arcsec) = ", neptune_25375_gaussfit_aparm(3)*sqrt(8.*alog(2.))*neptune_25375_str.cdelt2*3600.
;


; nocorr 		  --> Peak Intensity (Jy/beam) =       12.0715; Maj FWHM (arcsec) =       21.5152 ; Min FWHM (arcsec) =       18.1897
;
; 0.035s with rot_par_ang -->  
;
; 0.010s with rot_par_ang --> 
;
; 0.005s with rot_par_ang --> 
;
; 0.0s   with interpol    --> 
; 0.0s   with rot_par_ang --> 


init_obs, scan_number= 41234, type = 'map', init_obs_41234_str

traite_otf_map_main, scan_number= 41234, type = 'decorrel', neptune_41234_str, tau=0.7,/do_rcp

wei_max = max(neptune_41234_str.weight)
ind = where(neptune_41234_str.weight lt 0.15*wei_max)
neptune_41234_str.image(ind) = 0.

neptune_41234_gaussfit = gauss2dfit(neptune_41234_str.image,neptune_41234_gaussfit_aparm,/tilt)

print, "Zero Level (Jy/beam) = ", neptune_41234_gaussfit_aparm(0)
print, "Peak Intensity (Jy/beam) = ", neptune_41234_gaussfit_aparm(1)
print, "Delta x  (arcsec) = ", (neptune_41234_gaussfit_aparm(4)-neptune_41234_str.crpix1)*neptune_41234_str.cdelt1*3600.
print, "Delta y  (arcsec) = ", (neptune_41234_gaussfit_aparm(5)-neptune_41234_str.crpix2)*neptune_41234_str.cdelt2*3600.
print, "Position angle of major axis measured counterclockwise from x axis (deg) = ", neptune_41234_gaussfit_aparm(6)
print, "Maj FWHM (arcsec) = ", neptune_41234_gaussfit_aparm(2)*sqrt(8.*alog(2.))*neptune_41234_str.cdelt2*3600.
print, "Min FWHM (arcsec) = ", neptune_41234_gaussfit_aparm(3)*sqrt(8.*alog(2.))*neptune_41234_str.cdelt2*3600.


traite_otf_map_main, scan_number= 41234, type = 'chmap', neptune_ch_map_41234_str, tau=0.7
for i = 0, 255 do atv, neptune_ch_map_41234_str.ch_map(*,*,i)

traite_otf_map_main, scan_number= 43726, type = 'decorrel', neptune_43726_str, tau=0.45,/do_rcp
make_fits, neptune_43726_str

traite_otf_map_main, scan_number= 43726, type = 'decorrel',rmode = 'filt_sp', neptune_43726_filt, tau=0.45,/do_rcp

neptune_43726_str = neptune_43726_filt

wei_max = max(neptune_43726_str.weight)
ind = where(neptune_43726_str.weight lt 0.15*wei_max)
neptune_43726_str.image(ind) = 0.

neptune_43726_gaussfit = gauss2dfit(neptune_43726_str.image,neptune_43726_gaussfit_aparm,/tilt)

print, "Zero Level (Jy/beam) = ", neptune_43726_gaussfit_aparm(0)
print, "Peak Intensity (Jy/beam) = ", neptune_43726_gaussfit_aparm(1)
print, "Delta x  (arcsec) = ", (neptune_43726_gaussfit_aparm(4)-neptune_43726_str.crpix1)*neptune_43726_str.cdelt1*3600.
print, "Delta y  (arcsec) = ", (neptune_43726_gaussfit_aparm(5)-neptune_43726_str.crpix2)*neptune_43726_str.cdelt2*3600.
print, "Position angle of major axis measured counterclockwise from x axis (deg) = ", neptune_43726_gaussfit_aparm(6)
print, "Maj FWHM (arcsec) = ", neptune_43726_gaussfit_aparm(2)*sqrt(8.*alog(2.))*neptune_43726_str.cdelt2*3600.
print, "Min FWHM (arcsec) = ", neptune_43726_gaussfit_aparm(3)*sqrt(8.*alog(2.))*neptune_43726_str.cdelt2*3600.


;
traite_otf_map_main, scan_number= 43726, type = 'decorrel', neptune_43726_str, tau=0.45,/do_rcp
restore, work_dir+'apexdata/map_otf_xdr/E-083.C-0996A-2009/otf_subscan_43726_1.xdr', /verb
donnees_unfilt = donnees
donnees_red_unfilt = donnees_red
;
goodpix_ima = donnees.goodpix_ima
;
noise_fft_pro, donnees_red_unfilt, goodpix_ima, mean_level, mean_level_av, rms_noise, rms_noise_av, cube_pow_spec_unfilt, pow_spec_av_unfilt
;
taille = size(donnees.cube)
ndim = taille(3)
lst = donnees.lst
lst0 = lst(0:ndim-2)
lst1 = lst(1:ndim-1)

dt = dlst2dtloc(median(lst1-lst0))
print, "Sampling time (sec) :", dt 
  
time = findgen(ndim)*dt		; timeline in sec
sfint = 1./(ndim*dt)		; smallest non-zero positive frequency in Hz
frequency = findgen(1+ndim/2)*sfint
freqmax = 1./(2.*dt)		; Nyquist frequency (highest frequency that
;					; can be sampled)
;
wset, 20
plot, donnees.lst-donnees.lst(0), donnees_red_unfilt.cube(8,8,*)
;
wset, 21
pow_max = max(pow_spec_av_unfilt(0:ndim/2-2))
plot, frequency, pow_spec_av_unfilt(0:ndim/2), xtitle="Frequency (Hz)", $
ytitle="Relative amplitude", title="Mean power spectrum over valid pixels", $
xrange=[0,1.], yrange=[-0.1*pow_max/sqrt(2.),pow_max*1.05], /XSTYLE

;
;
traite_otf_map_main, scan_number= 43726, type = 'decorrel',rmode = 'filt_sp', neptune_43726_filt, tau=0.45,/do_rcp
;
restore, work_dir+'apexdata/map_otf_xdr/E-083.C-0996A-2009/otf_subscan_43726_1.xdr', /verb
donnees_filt = donnees
donnees_red_filt = donnees_red
;
wset, 20
plot, donnees.lst-donnees.lst(0), donnees_red_filt.cube(8,8,*)
;
noise_fft_pro, donnees_red_filt, goodpix_ima, mean_level, mean_level_av, rms_noise, rms_noise_av, cube_pow_spec_filt, pow_spec_av_filt
;
wset, 20
;pow_max = max(pow_spec_av_filt(0:ndim/2-2))
plot, frequency, pow_spec_av_filt(0:ndim/2), xtitle="Frequency (Hz)", $
ytitle="Relative amplitude", title="Mean power spectrum over valid pixels", $
xrange=[0,1.], yrange=[-0.1*pow_max/sqrt(2.),pow_max*1.05], /XSTYLE



;

traite_otf_map_main, scan_number= 43932, type = 'decorrel', neptune_43932_str, tau=0.85,/do_rcp

wei_max = max(neptune_43932_str.weight)
ind = where(neptune_43932_str.weight lt 0.15*wei_max)
neptune_43932_str.image(ind) = 0.

neptune_43932_gaussfit = gauss2dfit(neptune_43932_str.image,neptune_43932_gaussfit_aparm,/tilt)

print, "Zero Level (Jy/beam) = ", neptune_43932_gaussfit_aparm(0)
print, "Peak Intensity (Jy/beam) = ", neptune_43932_gaussfit_aparm(1)
print, "Delta x  (arcsec) = ", (neptune_43932_gaussfit_aparm(4)-neptune_43932_str.crpix1)*neptune_43932_str.cdelt1*3600.
print, "Delta y  (arcsec) = ", (neptune_43932_gaussfit_aparm(5)-neptune_43932_str.crpix2)*neptune_43932_str.cdelt2*3600.
print, "Position angle of major axis measured counterclockwise from x axis (deg) = ", neptune_43932_gaussfit_aparm(6)
print, "Maj FWHM (arcsec) = ", neptune_43932_gaussfit_aparm(2)*sqrt(8.*alog(2.))*neptune_43932_str.cdelt2*3600.
print, "Min FWHM (arcsec) = ", neptune_43932_gaussfit_aparm(3)*sqrt(8.*alog(2.))*neptune_43932_str.cdelt2*3600.


traite_otf_map_main, scan_number= 43947, type = 'decorrel', neptune_43947_str, tau=0.9,/do_rcp

wei_max = max(neptune_43947_str.weight)
ind = where(neptune_43947_str.weight lt 0.15*wei_max)
neptune_43947_str.image(ind) = 0.

neptune_43947_gaussfit = gauss2dfit(neptune_43947_str.image,neptune_43947_gaussfit_aparm,/tilt)

print, "Zero Level (Jy/beam) = ", neptune_43947_gaussfit_aparm(0)
print, "Peak Intensity (Jy/beam) = ", neptune_43947_gaussfit_aparm(1)
print, "Delta x  (arcsec) = ", (neptune_43947_gaussfit_aparm(4)-neptune_43947_str.crpix1)*neptune_43947_str.cdelt1*3600.
print, "Delta y  (arcsec) = ", (neptune_43947_gaussfit_aparm(5)-neptune_43947_str.crpix2)*neptune_43947_str.cdelt2*3600.
print, "Position angle of major axis measured counterclockwise from x axis (deg) = ", neptune_43947_gaussfit_aparm(6)
print, "Maj FWHM (arcsec) = ", neptune_43947_gaussfit_aparm(2)*sqrt(8.*alog(2.))*neptune_43947_str.cdelt2*3600.
print, "Min FWHM (arcsec) = ", neptune_43947_gaussfit_aparm(3)*sqrt(8.*alog(2.))*neptune_43947_str.cdelt2*3600.
