taille = size(donnees.cube)

lst = donnees.lst-donnees.lst(0)

rms_uncorr = 100.

white_noise = randomn(seed,taille(3))*rms_uncorr

noise = randomn(seed,taille(3))*rms_uncorr

signal = noise

signal = lowfreq_noise+white_noise

ft_signal = fft(signal)
pow_spec_signal = float(ft_signal*conj(ft_signal))

dt = 25e-3

lst = lst(id0:id1)
ndim = n_elements(signal)

time = findgen(ndim)*dt		; timeline in sec
sfint = 1./(ndim*dt)	; smallest non-zero positive frequency in Hz
;
frequency_pos = findgen(1+ndim/2)*sfint

if (ndim mod 2) eq 0 then frequency_neg = reverse(-frequency_pos(1:ndim/2-1))

if (ndim mod 2) eq 1 then frequency_neg = reverse(-frequency_pos(1:*)) 

frequency = [frequency_pos,frequency_neg]

ft_signal_trans = ft_signal

ft_signal_trans(1:*) = ft_signal(1:*)/abs(frequency(1:*))

lowfreq_noise = float(fft(ft_signal_trans,+1))

freqmax = 1./(2.*dt)	; Nyquist frequency (highest frequency that
				; can be sampled)
				
pow_max = max(pow_spec_signal(0:ndim/2))

wset, 20

plot, lst, noise

plot, lst, lowfreq_noise

plot, lst, lowfreq_noise+white_noise

plot, frequency, pow_spec_signal(0:ndim/2), xtitle="Frequency (Hz)", $
ytitle="Relative amplitude", title="Noise Power Spectrum", $
xrange=[0,3.], yrange=[-0.1*pow_max/sqrt(2.),pow_max*1.05], /XSTYLE

plot_oo, frequency(1:ndim/2), pow_spec_signal(1:ndim/2)

return
end

