PRO rcp_fun_gen_off, X, APAR, Funct, PDER
;
; e.g. Result = rcp_fun(dchan_var, apar) = [xpos,ypos]   Array of relative positions in arcsec
;
;	Funct = [xpos,ypos] = pix*cos(alpha)*X1 + pix*sin(alpha)*X2 + [xpos0,ypos0]
;
; X = [X1,X2] Independent variable (vector)
; N_el = n_elements(X) assumed to be an even number
; X1 = X(0:N_el/2-1)     ;   X2 = X(N_el/2:N_el-1)		X1 = [xchan,ychan]   X2 = [ychan,-xchan]
;
; APAR(0): pix   (pixel size)
; APAR(1): alpha (rotation angle of the array in rad)
; APAR(2): xpos0 (x_offset in arcsec)
; APAR(3): ypos0 (y_offset in arcsec)
;

N_el = n_elements(X)
X1 = X(0:N_el/2-1)
X2 = X(N_el/2:N_el-1)

N_el1 = n_elements(X1)


Funct = APAR(0)*cos(APAR(1))*X1 + APAR(0)*sin(APAR(1))*X2 + [X1(0:N_el1/2-1)*0+APAR(2),X1(N_el1/2:N_el1-1)*0+APAR(3)]

;
;    If the procedure is called with four parameters, calculate the
;    partial derivatives.
;
  IF N_PARAMS() GE 4 THEN BEGIN

	PDER0 = cos(APAR(1))*X1+sin(APAR(1))*X2
	PDER1 = APAR(0)*cos(APAR(1))*X2 - APAR(0)*sin(APAR(1))*X1
	PDER2 = [X1(0:N_el1/2-1)*0+1.,X1(N_el1/2:N_el1-1)*0]
	PDER3 = [X1(0:N_el1/2-1)*0,X1(N_el1/2:N_el1-1)*0+1.]

        PDER = [[PDER0], [PDER1], [PDER2], [PDER3]]
    
  ENDIF
;
  
END
