pro simu_noise, noise, ndim, rms_white, knee_freq, nseed = nseed
;
; simu_noise, noise, 2400, 100, 1.0, nseed=1
; simu_noise, noise, 2400, 100, 1.0

if keyword_set(nseed) then begin

  white_noise = randomn(nseed,ndim)*rms_white
  lowfreq_noise = randomn(nseed+1,ndim)*rms_white
  
endif else begin

  white_noise = randomn(seed,ndim)*rms_white
  lowfreq_noise = randomn(seed,ndim)*rms_white
  
endelse
;
;
;print, " rms(white_noise) = ", stdev(white_noise)

signal = lowfreq_noise

ft_signal = fft(signal)
pow_spec_signal = float(ft_signal*conj(ft_signal))

dt = 25e-3

time = findgen(ndim)*dt		; timeline in sec
sfint = 1./(ndim*dt)	; smallest non-zero positive frequency in Hz
;
frequency_pos = findgen(1+ndim/2)*sfint

if (ndim mod 2) eq 0 then frequency_neg = reverse(-frequency_pos(1:ndim/2-1))

if (ndim mod 2) eq 1 then frequency_neg = reverse(-frequency_pos(1:*)) 

frequency = [frequency_pos,frequency_neg]

ft_signal_trans = ft_signal

ft_signal_trans(1:*) = ft_signal(1:*)*knee_freq/abs(frequency(1:*))

lowfreq_noise = float(fft(ft_signal_trans,+1))

;
;print, " rms(lowfreq_noise) = ", stdev(lowfreq_noise)


freqmax = 1./(2.*dt)	; Nyquist frequency (highest frequency that
				; can be sampled)
				

noise = lowfreq_noise+white_noise

;
;print, " rms(noise) = ", stdev(noise)


wset, 20

;plot, time, noise, xtitle="Time (sec)", $
;ytitle="Amplitude", title="Timeline of Simulated Noise"


signal = noise

ft_signal = fft(signal)
pow_spec_signal = float(ft_signal*conj(ft_signal))

pow_max = max(pow_spec_signal(0:ndim/2))

wset, 21

;plot_oo, frequency(1:ndim/2), pow_spec_signal(1:ndim/2), xtitle="Frequency (Hz)", $
;ytitle="Relative amplitude", title="Power Spectrum of Simulated Noise"


return
end

