time = findgen(2001)-1000.			; timeline in sec
;
fwhm = 4.					; ~ 10"
;fwhm = 40.					; ~ 100"
;
beam = exp(-4.*alog(2.d0)*time^2/fwhm^2)
;
plot_io, time, 0.1+beam, yrange=[0.01,10.]


signal = beam

;
sm_fwhm = 4.*4.				; 10.*fwhm
sm_signal = fwhm/sqrt(fwhm^2+sm_fwhm^2)*exp(-4.*alog(2.d0)*time^2/(fwhm^2+sm_fwhm^2))

plot_io, time, 0.1+signal, yrange=[0.01,10.], xrange=[-500.,500.]
oplot, time, 0.1+sm_signal,color=130

plot, time, signal, yrange=[-0.1,1.1], xrange=[-100.,100.]
oplot, time, signal-sm_signal, color = 130

plot, time, signal-sm_signal, yrange=[-0.1,1.1], xrange=[-100.,100.]
oplot, time, signal-median(signal,sm_fwhm), color= 130


plot, time, signal, yrange=[-0.1,1.1], xrange=[-100.,100.]
;oplot, time, signal-median(signal,sm_fwhm), color = 130
oplot, time, signal-(median(signal,sm_fwhm)+reverse(median(signal,sm_fwhm)))/2., color = 130

plot, time, median(signal,sm_fwhm), yrange=[-0.1,1.1], xrange=[-100.,100.]



ft_signal = fft(signal)
pow_spec = float(ft_signal*conj(ft_signal))

dt = 1.
ndim = n_elements(time)


sfint = 1./(ndim*dt)	; smallest non-zero positive frequency in Hz
frequency = findgen(1+ndim/2)*sfint
freqmax = 1./(2.*dt)		; Nyquist frequency (highest frequency that
				; can be sampled)
wset, 0
plot, frequency, abs(ft_signal(0:ndim/2)), xtitle="Frequency (Hz)", $
ytitle="Relative amplitude", title="Fourier transform", /XSTYLE

;

id = where(abs(ft_signal(0:ndim/2)) gt max(abs(ft_signal(0:ndim/2)))/2.)

print, frequency(max(id))
print, 2.*alog(2.)/!pi/4.

;

scale_max = 40.			;    10.*fwhm_0
freq_min = 1./scale_max

; 
ind = where(frequency lt freq_min, count)		 	;  Positions of frequencies lower than minimum meaningful frequency 
;

ft_signal_filt = ft_signal
ft_signal_filt(ind) = complex(0,0)			;  killing low-frequency components  (< freq_min)
ft_signal_filt(ndim-ind) = complex(0,0)	
signal_filt = real_part(fft(ft_signal_filt,/inverse))


plot_io, time, 0.1+beam, yrange=[0.01,10.], xrange=[-500.,500.]

loadct, 15
oplot, time, 0.1+signal_filt, color=130

plot, time, 0.1+signal_filt
plot, time, signal-signal_filt





pro noise_fft_pro, donnees, goodpix_ima, mean_level, mean_level_av, rms_noise, rms_noise_av, cube_pow_spec, pow_spec_av, ndim = ndim, sub_mean = sub_mean


if n_params() eq 0 then begin
	print, 'Calling sequence :'
	print, '	NOISE_FFT_PRO, Donnees, Goodpix_ima, Mean_level, Mean_level_av, Rms_noise, Rms_noise_av, Cube_pow_spec, Pow_spec_av
	return
endif	

taille = size(donnees.cube)
mean_level = fltarr(taille(1),taille(2))
rms_noise = fltarr(taille(1),taille(2))
nchan = taille(1)*taille(2)

if not keyword_set(ndim) then begin
  ndim = taille(3)
endif

;print, "ndim = ", ndim

cube = (donnees.cube)(*,*,0:ndim-1)

cube_pow_spec = cube*0.
index = where(goodpix_ima gt 0)

lst = (donnees.lst)(0:ndim-1)
lst0 = lst(0:ndim-2)
lst1 = lst(1:ndim-1)

dt = dlst2dtloc(median(lst1-lst0))

time = findgen(ndim)*dt		; timeline in sec
sfint = 1./(ndim*dt)	; smallest non-zero positive frequency in Hz
frequency = findgen(1+ndim/2)*sfint
freqmax = 1./(2.*dt)	; Nyquist frequency (highest frequency that
				; can be sampled)

for j = 0, taille(2)-1 do begin
   for i = 0, taille(1)-1 do begin
;     if goodpix_ima(i,j) gt 0. then begin
	rms_noise(i,j)   = stdev(cube(i,j,*))
        signal = cube(i,j,*)
      if keyword_set(sub_mean) then begin
	mean_level(i,j)  = mean(signal)
	signal = signal-mean_level(i,j)
      endif	
	ft_signal = fft(signal)
	pow_spec = float(ft_signal*conj(ft_signal))
	cube_pow_spec(i,j,*) = pow_spec
;     endif
   endfor
endfor

mean_level_av = mean(mean_level(index))
rms_noise_av = mean(rms_noise(index))
pow_spec_ref = reform(cube_pow_spec,nchan,ndim)
pow_spec_av = fltarr((size(index))(1),ndim)
pow_spec_av = pow_spec_ref(index,0:ndim-1)

pow_spec_av = total(pow_spec_av,1)/(size(index))(1)

;print, "Mean rms noise over valid pixels : ", rms_noise_av

;
;wset, 0
;plot, frequency, pow_spec_av(0:ndim/2), xtitle="Frequency (Hz)", $
;ytitle="Relative amplitude", title="Mean power spectrum over valid pixels", $
;xrange=[0,freqmax/1.7], yrange=[-2e-10,14e-10], /XSTYLE
;
;			PRINTING POWER SPECTRUM
;
;set_plot,'ps'
;device,file="/users/artemis/Desktop/pow_spec.ps"

;plot, frequency, pow_spec_av(0:ndim/2), xtitle="Frequency (Hz)", $
;ytitle="Relative amplitude", title="Mean power spectrum over valid pixels", $
;xrange=[0,freqmax/1.7], yrange=[-2e-10,14e-10], /XSTYLE

;device,/close
;set_plot,'x'

return
end

