; planet_artemis_rcp.pro: "Batch" IDL file 
;
; @obs1_artemis_config

; 350 microns focal plane : 64 x 36 = 2304 pixels in ArTeMiS350 2014
n_channel_x = 73      ; including 3*3 fake pixels between subarrays
n_channel_y = 39      ; including 3 fake pixels between subarrays

npix_eff = 73L*39L    ; including gaps

nx_chan = indgen(n_channel_x)#(transpose(intarr(n_channel_y))+1)
ny_chan = (intarr(n_channel_x)+1)#transpose(indgen(n_channel_y))

mask_jun14 = intarr(n_channel_x,n_channel_y)+1
mask_jun14(16:18,*) = 0
mask_jun14(35:37,*) = 0
mask_jun14(54:56,*) = 0
mask_jun14(*,18:20) = 0

mask_jun14_1 = mask_jun14*0
mask_jun14_1(0:15,0:17) = 1

mask_jun14_2 = mask_jun14*0
mask_jun14_2(19:34,0:17) = 1

mask_jun14_3 = mask_jun14*0
mask_jun14_3(38:53,0:17) = 1

mask_jun14_4 = mask_jun14*0
mask_jun14_4(57:72,0:17) = 1

mask_jun14_5 = mask_jun14*0
mask_jun14_5(0:15,21:38) = 1

mask_jun14_6 = mask_jun14*0
mask_jun14_6(19:34,21:38) = 1

mask_jun14_7 = mask_jun14*0
mask_jun14_7(38:53,21:38) = 1

mask_jun14_8 = mask_jun14*0
mask_jun14_8(57:72,21:38) = 1

n_jun14 = 8

;;;;;

mask_arr_jun14 = intarr(n_channel_x,n_channel_y,n_jun14)
;
mask_arr_jun14(*,*,0) = mask_jun14_1
mask_arr_jun14(*,*,1) = mask_jun14_2
mask_arr_jun14(*,*,2) = mask_jun14_3
mask_arr_jun14(*,*,3) = mask_jun14_4
;
mask_arr_jun14(*,*,4) = mask_jun14_5
mask_arr_jun14(*,*,5) = mask_jun14_6
mask_arr_jun14(*,*,6) = mask_jun14_7
mask_arr_jun14(*,*,7) = mask_jun14_8


ind_jun14 = where(mask_jun14 gt 0, nchan_eff)					;   2304 pixels

print, nchan_eff  			; Effective number of 350mu bolometer channels in 2014

; nchan_eff = 64*36	   		; Effective number of 350mu bolometer channels in 2014

;

noise_fft_skydip, 31616, sky_31616_str, /nopowermap 	    	    	    	    ;  0.84579853 +-      0.015374540    (PWV = 0.31 mm)

noise_fft_skydip, 31648, sky_31648_str, /nopowermap 	    	    	    	    ;  0.76411593 +-      0.011234110    (PWV = 0.27 mm)

noise_fft_skydip, 31665, sky_31665_str, /nopowermap 	    	    	    	    ;  0.80231074 +-     0.0064807314    (PWV = 0.26 mm)

;

init_obs, scan_number= 31646, type = 'map', init_obs_31646_str
traite_otf_map_main, scan_number= 31646, type = 'decorrel', uranus_31646_str, tau=0.79,/newreduc   	    ;  238. Jy/beam with Conv = 1.e-5 and flat_mars_30227_jun14.xdr

traite_otf_map_main, scan_number= 31646, type = 'decorrel', uranus_31646_str, tau=0.79,/newreduc  	    ;  Using Conv = 1.e-5 and flat_def_2014.xdr

traite_otf_map_main, scan_number= 31646, type = 'chmap', planet_ch_map_decorrel_31646_str, tau=0.79	    ;  Using "donnees_red" from previous step


;for j = 0, nchan_eff-1 do atv, planet_ch_map_31646_str.ch_map(*,*,ind_jun14(j))
for j = 0, nchan_eff-1 do atv, planet_ch_map_decorrel_31646_str.ch_map(*,*,ind_jun14(j))

planet_ch_map_31646_str = planet_ch_map_decorrel_31646_str
planet_ch_map_decorrel_31646_str = 0

;

taille_ch_map = size(planet_ch_map_31646_str.ch_map)

x_ch_map = indgen(taille_ch_map(1))#(transpose(intarr(taille_ch_map(2)))+1)
y_ch_map = (intarr(taille_ch_map(1))+1)#transpose(indgen(taille_ch_map(2)))

planet_31646_gaussfit_apar = fltarr(7,npix_eff)
 
for j = 0, nchan_eff-1 do begin & i = ind_jun14(j) & $
   print, " Channel (64*36) ", j,  "     Channel (73*39) ", i & $
   max_ch_map = max(planet_ch_map_31646_str.ch_map(*,*,i),imax) & $
   xmin = max([x_ch_map(imax)-50,0]) & xmax = min([x_ch_map(imax)+50,taille_ch_map(1)-1]) & ymin = max([y_ch_map(imax)-50,0]) & ymax = min([y_ch_map(imax)+50,taille_ch_map(1)-1]) & $
   if max(abs(planet_ch_map_31646_str.ch_map(*,*,i))) gt 0. then planet_small_ch_map = planet_ch_map_31646_str.ch_map(xmin:xmax,ymin:ymax,i) & $
   if max(abs(planet_ch_map_31646_str.ch_map(*,*,i))) gt 0. then planet_31646_gaussfit = gauss2dfit(planet_small_ch_map,gaussfit_apar,/tilt) & $
   if max(abs(planet_ch_map_31646_str.ch_map(*,*,i))) gt 0. then planet_31646_gaussfit_apar(*,i) = gaussfit_apar & $
   if max(abs(planet_ch_map_31646_str.ch_map(*,*,i))) gt 0. then planet_31646_gaussfit_apar(4,i) = planet_31646_gaussfit_apar(4,i)+xmin & $
   if max(abs(planet_ch_map_31646_str.ch_map(*,*,i))) gt 0. then planet_31646_gaussfit_apar(5,i) = planet_31646_gaussfit_apar(5,i)+ymin & $   
   print, "Zero Level (Jy/beam) = ", planet_31646_gaussfit_apar(0,i) & $
   print, "Peak Intensity (Jy/beam) = ", planet_31646_gaussfit_apar(1,i) & $
   print, "Delta x  (arcsec) = ", (planet_31646_gaussfit_apar(4,i)-planet_ch_map_31646_str.crpix1)*planet_ch_map_31646_str.cdelt1*3600. & $
   print, "Delta y  (arcsec) = ", (planet_31646_gaussfit_apar(5,i)-planet_ch_map_31646_str.crpix2)*planet_ch_map_31646_str.cdelt2*3600. & $
   print, "Position angle of major axis measured counterclockwise from x axis (deg) = ", planet_31646_gaussfit_apar(6,i) & $
   print, "Maj FWHM (arcsec) = ", planet_31646_gaussfit_apar(2,i)*sqrt(8.*alog(2.))*planet_ch_map_31646_str.cdelt2*3600. & $
   print, "Min FWHM (arcsec) = ", planet_31646_gaussfit_apar(3,i)*sqrt(8.*alog(2.))*planet_ch_map_31646_str.cdelt2*3600. & $
   print, "       " & $
endfor

;;;;;;
;;;;;;


;;;

flat_planet_31646 = fltarr(npix_eff)
nx_ref_pix = 31  ;  34  ;  19						; Reference pixel for Calibration (31,15)  Conv = 7.75856e-06
ny_ref_pix = 15  ;  17	;    21
;print, where(nx_chan eq 31 and ny_chan eq 15)  ;print, where(nx_chan eq 34 and ny_chan eq 17)
; 
n_ref_pix = 1126    ;  1275					    	;  pixel de reference dans la matrice ArTeMiS350_2014 (73x39) : (34,17) <--> 1275 (IDL)
;
peak_ref = planet_31646_gaussfit_apar(1,n_ref_pix)			;  Peak intensity in map made with reference bolometer channel
flat_planet_31646(*) = planet_31646_gaussfit_apar(1,*)/peak_ref
flat_planet_31646 = reform(flat_planet_31646,n_channel_x,n_channel_y)
flat_field = flat_planet_31646						;  0.2 -> 10

;

;goodpix_ima = fltarr(n_channel_x,n_channel_y)+1.
;;ind = where(flat_field lt 0.2 or flat_field gt 5.)
;ind = where(flat_field lt 0.5 or flat_field gt 2.)
;goodpix_ima(ind) = 0.

;goodpix_ima_7339 = goodpix_ima

;goodpix_ima_7339_arr1 = goodpix_ima_7339*mask_jun14_1*goodpix_ima_noise
;goodpix_ima_7339_arr2 = goodpix_ima_7339*mask_jun14_2*goodpix_ima_noise
;goodpix_ima_7339_arr3 = goodpix_ima_7339*mask_jun14_3*goodpix_ima_noise
;goodpix_ima_7339_arr4 = goodpix_ima_7339*mask_jun14_4*goodpix_ima_noise
;goodpix_ima_7339_arr5 = goodpix_ima_7339*mask_jun14_5*goodpix_ima_noise
;goodpix_ima_7339_arr6 = goodpix_ima_7339*mask_jun14_6*goodpix_ima_noise
;goodpix_ima_7339_arr7 = goodpix_ima_7339*mask_jun14_7*goodpix_ima_noise
;goodpix_ima_7339_arr8 = goodpix_ima_7339*mask_jun14_8*goodpix_ima_noise

;;;

conv_planet_31646 = fltarr(npix_eff)
flux_planet = 192.26										; Peak flux density of Uranus 192.26 in Jy/beam on 3 Jun 2014 (**To be edited**)
conv_planet_31646(*) = init_obs_31646_str.conv*planet_31646_gaussfit_apar(1,*)/flux_planet
conv_planet_31646 = reform(conv_planet_31646,n_channel_x,n_channel_y)				; 3e-6 -> 2e-5 (with atmospheric correction)


peak_flux_arr_planet_31646 = fltarr(npix_eff)									
peak_flux_arr_planet_31646(*) = planet_31646_gaussfit_apar(1,*)
peak_flux_arr_planet_31646 = reform(peak_flux_arr_planet_31646,n_channel_x,n_channel_y)			

;ind_arr1 = where(goodpix_ima_7339_arr1)    	    	    	    	; no pixels
ind_arr2 = where(goodpix_ima_7339_arr2)
ind_arr3 = where(goodpix_ima_7339_arr3)
ind_arr4 = where(goodpix_ima_7339_arr4)
ind_arr5 = where(goodpix_ima_7339_arr5)
ind_arr6 = where(goodpix_ima_7339_arr6)
ind_arr7 = where(goodpix_ima_7339_arr7)
ind_arr8 = where(goodpix_ima_7339_arr8)
    	    	    	    	    	    	    	    	    	; Uranus # 31646    ; Uranus # 31301
print, median(peak_flux_arr_planet_31646(ind_arr2))			; 256.226	    ; 227.438
print, median(peak_flux_arr_planet_31646(ind_arr3))			; 204.820 	    ; 160.818 
print, median(peak_flux_arr_planet_31646(ind_arr4)) 	    	    	; 325.928	    ; 271.656
print, median(peak_flux_arr_planet_31646(ind_arr5)) 	    	    	; 219.952	    ; 189.621
print, median(peak_flux_arr_planet_31646(ind_arr6))			; 268.742	    ; 235.067
print, median(peak_flux_arr_planet_31646(ind_arr7))			; 317.888	    ; 262.727
print, median(peak_flux_arr_planet_31646(ind_arr8)) 	    	    	; 311.707	    ; 265.795
    	    	    	    	    	    	    	    	    	; Uranus # 31646    ; Uranus # 31301	 ; Mars # 30227
print, median(conv_planet_31646(ind_arr2))				; 1.33271e-05	    ; 1.18297e-05	 ; 7.61645e-06
print, median(conv_planet_31646(ind_arr3))				; 1.06533e-05	    ; 8.36459e-06	 ; 4.89879e-06
print, median(conv_planet_31646(ind_arr4))				; 1.69525e-05	    ; 1.41296e-05	 ; 8.09564e-06
print, median(conv_planet_31646(ind_arr5))				; 1.14403e-05	    ; 9.86276e-06	 ; 6.18078e-06
print, median(conv_planet_31646(ind_arr6))				; 1.39780e-05	    ; 1.22265e-05	 ; 7.73252e-06
print, median(conv_planet_31646(ind_arr7))				; 1.65343e-05	    ; 1.36652e-05	 ; 7.79913e-06
print, median(conv_planet_31646(ind_arr8))  	    	    	    	; 1.62128e-05	    ; 1.38248e-05	 ; 8.14055e-06

ind_good = where(goodpix_ima_7339*goodpix_ima_noise)
print, median(conv_planet_31646(ind_good))  	    	    	    	; 1.43528e-05	    ; 6.96814e-06	    ; 7.59117e-06

;

daz_planet = fltarr(n_channel_x,n_channel_y)
del_planet = fltarr(n_channel_x,n_channel_y)

daz_planet(*) = -(planet_31646_gaussfit_apar(4,*)-planet_ch_map_31646_str.crpix1)*planet_ch_map_31646_str.cdelt1*3600.
del_planet(*) = -(planet_31646_gaussfit_apar(5,*)-planet_ch_map_31646_str.crpix2)*planet_ch_map_31646_str.cdelt2*3600.

daz_planet0 = daz_planet(34,17)		     ;  Reference pixel = (34,17) in 73*39 grid
del_planet0 = del_planet(34,17)

daz_planet = daz_planet-daz_planet0
del_planet = del_planet-del_planet0


daz_planet_31646 = daz_planet 
del_planet_31646 = del_planet

;goodpix_ima(19:34,4) = 0.
;goodpix_ima(49,38) = 0.
;goodpix_ima(64,10) = 0.
;goodpix_ima(19,35) = 0.
;goodpix_ima(0,21:37) = 0.
;goodpix_ima(38,35) = 0.
;goodpix_ima(57,31) = 0.
;goodpix_ima(57,35:37) = 0.
;goodpix_ima(70:72,3) = 0.
;goodpix_ima(53,11) = 0.
;goodpix_ima(53,3) = 0.
;goodpix_ima(53,0) = 0.
;goodpix_ima(52,0) = 0.

goodpix_ima(0,21:37) = 0.
goodpix_ima(19,35) = 0.
;goodpix_ima(19,3) = 0.
goodpix_ima(38,35) = 0.
goodpix_ima(44,1) = 0.
goodpix_ima(46,1) = 0.
goodpix_ima(53,11) = 0.
goodpix_ima(53,7) = 0.
goodpix_ima(53,3) = 0.
goodpix_ima(53,0) = 0.
goodpix_ima(52,0) = 0.
goodpix_ima(57,31) = 0.
goodpix_ima(57,35:37) = 0.
goodpix_ima(70:72,3) = 0.

dx_planet = -daz_planet				;  Ignoring any rotation
dy_planet = del_planet

atv, dx_planet*goodpix_ima
atv, dy_planet*goodpix_ima

;

nxchan = indgen(n_channel_x)#(transpose(intarr(n_channel_y))+1)
nychan = (intarr(n_channel_x)+1)#transpose(indgen(n_channel_y))

pix = 3.8
alpha = 0.

;; All 8 sub-arrays

index = where(goodpix_ima eq 1)
;;;;;index = where(goodpix_ima_7339 eq 1)

dpos_planet  = [dx_planet(index),dy_planet(index)]
;;;;;;;;dpos_planet  = [-dx_planet(index),dy_planet(index)]
dchan   = [(nxchan-nx_ref_pix)(index),(nychan-ny_ref_pix)(index)]
dchan_t = [(nychan-ny_ref_pix)(index),-(nxchan-nx_ref_pix)(index)]

;

dchan_var = float([dchan,dchan_t])		;  Vector of "independent variables"
dpos_var  = dpos_planet				;  Vector of "dependent variables"

chi_red = 0.
apar = [pix, alpha]
rms = apar*0.
weights = dpos_var*0.+1.
;
.run rcp_fun
rcp_fit = CURVEFIT(dchan_var,dpos_var,Weights,APAR,RMS,CHISQ=chi_red,FUNCTION_NAME='rcp_fun')
;
print, "Pixel size (arcsec) : ", apar(0), " +- ", rms(0)						; 3.79064 +-    0.00105271
print, "Rotation angle of the array (deg) : ", apar(1)*180./!pi," +- ", rms(1)*180./!pi			; -12.1984 +-     0.0162659


; 

chi_red = 0.
xpos0 = 0.
ypos0 = 0.
apar = [pix, alpha, xpos0, ypos0]
rms = apar*0.
weights = dpos_var*0.+1.
;
rcp_fit = CURVEFIT(dchan_var,dpos_var,Weights,APAR,RMS,CHISQ=chi_red,FUNCTION_NAME='rcp_fun_off')
;
print, "Pixel size (arcsec) : ", apar(0), " +- ", rms(0)					 	; 3.78689 +-    0.00109353
print, "Rotation angle of the array (deg) : ", apar(1)*180./!pi," +- ", rms(1)*180./!pi		 	; -12.1451 +-     0.0169127
print, "X_offset (arcsec) : ", apar(2), " +- ", rms(2)						 	; 0.0924349 +-     0.0256026
print, "Y_offset (arcsec) : ", apar(3), " +- ", rms(3)						 	; 0.486451 +-     0.0256026

;

chi_red = 0.
xpos0 = 0.
ypos0 = 0.
apar = [pix, alpha, xpos0, ypos0]
rms = apar*0.
weights = dpos_var*0.+1.
;
.r rcp_fun_gen_off
rcp_fit = CURVEFIT(dchan_var,dpos_var,Weights,APAR,RMS,CHISQ=chi_red,FUNCTION_NAME='rcp_fun_gen_off')
;
print, "Pixel size (arcsec) : ", apar(0), " +- ", rms(0)						; 3.87103 +-    0.00109353
print, "Rotation angle of the array (deg) : ", apar(1)*180./!pi," +- ", rms(1)*180./!pi			; -11.9679 +-     0.0161855
print, "X_offset (arcsec) : ", apar(2), " +- ", rms(2)							; 0.0924335 +-     0.0256026
print, "Y_offset (arcsec) : ", apar(3), " +- ", rms(3)							; 0.486451 +-     0.0256026

;;;;;;;;;;;;;;;elev = 39.3	;  deg    Mean Elevation of planet during scan 31646			NB:  No Nasmyth rotation at Cassegrain focus --> elev does not matter

;;;;;;;;;;;;;;;ROT_dazdel2dxdy, daz_planet, del_planet, elev, dx_planet, dy_planet

artemis350_dazdel2dxdy, daz_planet, del_planet, dx_planet_rot, dy_planet_rot

dx_planet_31646 = dx_planet_rot
dy_planet_31646 = dy_planet_rot


atv, dx_planet_31646*goodpix_ima
atv, dy_planet_31646*goodpix_ima

dx_planet = dx_planet_rot
dy_planet = dy_planet_rot

;

dx_rcp = dx_planet_31646
dy_rcp = dy_planet_31646


nxchan = indgen(n_channel_x)#(transpose(intarr(n_channel_y))+1)
nychan = (intarr(n_channel_x)+1)#transpose(indgen(n_channel_y))

pix = 3.87
alpha = 0.

index = where(goodpix_ima eq 1)

dpos_planet  = [dx_planet(index),dy_planet(index)]
;;;;;;;dpos_planet  = [-dx_planet(index),dy_planet(index)]
dchan   = [(nxchan-nx_ref_pix)(index),(nychan-ny_ref_pix)(index)]
dchan_t = [(nychan-ny_ref_pix)(index),-(nxchan-nx_ref_pix)(index)]


print, "Simple estimate of the pixel size (arcsec) : ", correlate(dchan,dpos_planet,/covariance)/(sigma(dchan))^2	   ; Simple estimate of the pixel size (arcsec): 3.87164

dchan_var = float([dchan,dchan_t])		;  Vector of "independent variables"
dpos_var  = dpos_planet				;  Vector of "dependent variables"

chi_red = 0.
apar = [pix, alpha]
rms = apar*0.
weights = dpos_var*0.+1.
;
.run rcp_fun
;rcp_fit = LMFIT(dchan_var,dpos_var,APAR,SIGMA=RMS,CHISQ=chi,FUNCTION_NAME='rcp_fun')
rcp_fit = CURVEFIT(dchan_var,dpos_var,Weights,APAR,RMS,CHISQ=chi_red,FUNCTION_NAME='rcp_fun')
;
print, "Pixel size (arcsec) : ", apar(0), " +- ", rms(0)								   ; 3.87560 +-    0.00105271  	  arcsec
print, "Rotation angle of the array (deg) : ", apar(1)*180./!pi," +- ", rms(1)*180./!pi		 			   ; -0.0189847 +-     0.0155630  deg

; 

chi_red = 0.
xpos0 = 0.
ypos0 = 0.
apar = [pix, alpha, xpos0, ypos0]
rms = apar*0.
weights = dpos_var*0.+1.
;
rcp_fit = CURVEFIT(dchan_var,dpos_var,Weights,APAR,RMS,CHISQ=chi_red,FUNCTION_NAME='rcp_fun_off')
;
print, "Pixel size (arcsec) : ", apar(0), " +- ", rms(0)						; 3.87103 +-    0.00109347
print, "Rotation angle of the array (deg) : ", apar(1)*180./!pi," +- ", rms(1)*180./!pi			; 0.0320813 +-     0.0161846
print, "X_offset (arcsec) : ", apar(2), " +- ", rms(2)							; 0.191553 +-     0.0256012
print, "Y_offset (arcsec) : ", apar(3), " +- ", rms(3)							; 0.456602 +-     0.0256012

; 

chi_red = 0.
xpos0 = 0.
ypos0 = 0.
apar = [pix, alpha, xpos0, ypos0]
rms = apar*0.
weights = dpos_var*0.+1.
;
.r rcp_fun_gen_off
rcp_fit = CURVEFIT(dchan_var,dpos_var,Weights,APAR,RMS,CHISQ=chi_red,FUNCTION_NAME='rcp_fun_gen_off')
;
print, "Pixel size (arcsec) : ", apar(0), " +- ", rms(0)						;  3.87103 +-	 0.00109347
print, "Rotation angle of the array (deg) : ", apar(1)*180./!pi," +- ", rms(1)*180./!pi			;  0.0320810 +-     0.0161846
print, "X_offset (arcsec) : ", apar(2), " +- ", rms(2)							;  0.191554 +-     0.0256012
print, "Y_offset (arcsec) : ", apar(3), " +- ", rms(3)							;  0.456602 +-     0.0256012


;;;;;;;;
;;;;;;;;	Saving rcp results in 350mu focal plane reference frame (64 x 36 grid)
;;;;;;;;

goodpix_ima_7339 = goodpix_ima				    	    ;    73*39 grid  (ArTeMiS350 Jun2014, counting gaps between subarrays)
goodpix_ima_7339(19,3) = 0.
flat_field_7339 = flat_field				    	    ;    73*39 grid  (ArTeMiS350 Jun2014)
flat_field_7339 = flat_field_7339*goodpix_ima_7339
ind_flat_def = where(flat_field_7339 eq 0 and mask_jun14 eq 1)
flat_field_7339(ind_flat_def) = 1.
;
dx_rcp_7339 = dx_rcp					    	    ;    73*39 grid  (ArTeMiS350 Jun2014)
dy_rcp_7339 = dy_rcp					    	    ;    73*39 grid  (ArTeMiS350 Jun2014)

; 
;goodpix_ima = focal2img350(goodpix_ima_7339)		    	    ;    64*36 grid  (BoA)
goodpix_ima = focal2img350(goodpix_ima_7339*goodpix_ima_noise)	    ;    64*36 grid  (BoA)
flat_field  = focal2img350(flat_field_7339)		    	    ;    64*36 grid
dx_rcp	    = focal2img350(dx_rcp_7339)			    	    ;    64*36 grid
dy_rcp	    = focal2img350(dy_rcp_7339)			    	    ;    64*36 grid

;

hpbw_31646 = sqrt(planet_31646_gaussfit_apar(2,*)*sqrt(8.*alog(2.))*planet_ch_map_31646_str.cdelt2*3600.*planet_31646_gaussfit_apar(3,*)*sqrt(8.*alog(2.))*planet_ch_map_31646_str.cdelt2*3600.)

hpbw_31646 = reform(hpbw_31646,n_channel_x,n_channel_y)

atv, hpbw_31646*goodpix_ima_7339

;

nchan_350 = 64*36

;for i = 0, nchan_350-1 do print, i+1, " ", flat_field(i), "  ", goodpix_ima(i), " ", dx_rcp(i), "  ", dy_rcp(i)

openw, 1, work_dir+'Calib_partemis/artemis_planet_31646_rcp.dat'
for i = 0, nchan_350-1 do printf, 1, i+1, " ", flat_field(i), "  ", goodpix_ima(i), " ", dx_rcp(i), "  ", dy_rcp(i)
close, 1

;

save, file = work_dir+'Calib_partemis/rcp_mars_31646_jun14.xdr', dx_rcp, dy_rcp, /verb

save, file = work_dir+'Calib_partemis/flat_mars_31646_jun14.xdr', flat_field , /verb

save, file = work_dir+'Calib_partemis/goodpix_ima_mars_31646_jun14.xdr', goodpix_ima

 
;

restore, work_dir+'Calib_partemis/flat_mars_31646_jun14.xdr', /verb              ; <-- flat_field        (64,36)
restore, work_dir+'Calib_partemis/goodpix_ima_mars_31646_jun14.xdr', /verb       ; <-- goodpix_ima       (64,36)
restore, work_dir+'Calib_partemis/rcp_mars_31646_jun14.xdr', /verb		 ; <-- dx_rcp, dy_rcp    (64,36)

flat_field_7339  = img2focal350(flat_field)	; (73,39), normalized to 1.0 for pixel (34,17)				
goodpix_ima_7339 = img2focal350(goodpix_ima)
dx_rcp_7339 = img2focal350(dx_rcp)
dy_rcp_7339 = img2focal350(dy_rcp)

artemis350_dxdy2dazdel, dx_rcp_7339, dy_rcp_7339, daz_planet, del_planet

;

readcol, work_dir+'Calib_partemis/ARTEMIS350_myp10.rcp', feed, gain, boa_x, boa_y

openw, 1, work_dir+'Calib_partemis/artemis_mars_boa_31646_rcp.dat'
for i = 0, nchan_350-1 do begin $
& if (focal2mbfits(goodpix_ima_7339))(i) eq 0 then printf, 1, i+1, " ", (focal2mbfits(flat_field_7339))(i), "  ", (focal2mbfits(goodpix_ima_7339))(i), " ", boa_x(i), "  ", boa_y(i) $
& if (focal2mbfits(goodpix_ima_7339))(i) eq 1 then printf, 1, i+1, " ", (focal2mbfits(flat_field_7339))(i), "  ", (focal2mbfits(goodpix_ima_7339))(i), " ", (focal2mbfits(daz_planet))(i), "  ", (focal2mbfits(del_planet))(i) & $
endfor

close, 1


;;;;;;;
;;;;;;;

traite_otf_map_main, scan_number= 31646, type = 'map', mars_otf_31646_str, tau=1.12, /newreduc

;traite_otf_map_main, scan_number= 31646, type = 'map', mars_31646_str, tau=1.12,/newreduc

mars_otf_31646_str_flat31646 = mars_otf_31646_str
mars_otf_31646_str_flat31646_decorrel = mars_otf_31646_str

;

;mars_otf_31646_str = mars_31646_str

image = mars_otf_31646_str.image

gaussfit = gauss2dfit(image,gaussfit_aparm,/tilt)

print, "Zero Level (Jy/beam) = ", gaussfit_aparm(0)									; 0.941842  	    	    	    	    1.0480  			    
print, "Peak Intensity (Jy/beam) = ", gaussfit_aparm(1)									; 4016.38     Conv = 0.0775856 (31,15)	    4469.10 ; Conv = 0.0518 (34,17)					    
print, "Delta x  (arcsec) = ", (gaussfit_aparm(4)-mars_otf_31646_str.crpix1)*mars_otf_31646_str.cdelt1*3600.		; -1.2633347
print, "Delta y  (arcsec) = ", (gaussfit_aparm(5)-mars_otf_31646_str.crpix2)*mars_otf_31646_str.cdelt2*3600.		; 3.0980781
print, "Position angle of major axis measured counterclockwise from x axis (deg) = ", gaussfit_aparm(6)			; -0.539990
print, "Maj FWHM (arcsec) = ", gaussfit_aparm(2)*sqrt(8.*alog(2.))*mars_otf_31646_str.cdelt2*3600.			; 16.5407
print, "Min FWHM (arcsec) = ", gaussfit_aparm(3)*sqrt(8.*alog(2.))*mars_otf_31646_str.cdelt2*3600.			; 14.5418


make_fits, mars_otf_31646_str, fileout='mars_otf_31646'

mars_otf_31646_str_off10 = mars_otf_31646_str
ind_nonan = where(mars_otf_31646_str.image ne 0.0)
mars_otf_31646_str_off10.image = mars_otf_31646_str.image*0.
mars_otf_31646_str_off10.image(ind_nonan) = mars_otf_31646_str.image(ind_nonan) + 10.
;
make_fits, mars_otf_31646_str_off10, fileout='mars_otf_31646_off10'

;

traite_otf_map_main, scan_number= 31646, type = 'decorrel', mars_otf_31646_decorrel_str, tau=1.3, /newreduc

mars_otf_31646_decorrel_str_off20 = mars_otf_31646_decorrel_str
ind_nonan = where(mars_otf_31646_decorrel_str.image ne 0.0)
mars_otf_31646_decorrel_str_off20.image = mars_otf_31646_decorrel_str.image*0.
mars_otf_31646_decorrel_str_off20.image(ind_nonan) = mars_otf_31646_decorrel_str.image(ind_nonan) + 20.
;
make_fits, mars_otf_31646_decorrel_str_off20, fileout='mars_otf_31646_decorrel_off20'


;;;;;;;
;;;;;;;

;;;;;
;;;;;
;;;;;

init_obs, scan_number= 30236, type = 'map', init_obs_30236_str

goodpix_ima_7339 = init_obs_30236_str.goodpix_ima

;;traite_otf_map_main, scan_number=30236, type = 'decorrel', cosmos_30236_str, tau=1.33, /newreduc		; "blank" field - pb with 1 subscan ?	 PWV = 0.60 mm

traite_otf_map_main, scan_number=30236, type = 'decorrel', cosmos_tau0_str, tau=1e-6, /newreduc		    	; "blank" COSMOS field		 PWV = 0.65 mm

ind_high_weight = where(cosmos_tau0_str.weight gt 700.)
masked_weight = cosmos_tau0_str.weight*0.
masked_weight(ind_high_weight) = (cosmos_tau0_str.weight)(ind_high_weight)

print, stdev((cosmos_tau0_str.image)(ind_high_weight))	    	    	    	    	    	    	    	;  rms = 0.0761843 Jy

;;;;;

liste = findfile('../../apexdata/map_otf_xdr/T-091.F-0008-2013/otf_subscan_30236_*.xdr')

nefd_cube = fltarr(73,39,n_elements(liste))

for k = 0, n_elements(liste)-1 do begin restore, liste(k) & $
 print, "Subscan ", k & $
 for j = 0, 39-1 do begin & $
  for i = 0, 73-1 do begin & $
    nefd_cube(i,j,k) = (1/sqrt(40.))*stdev(donnees_red.cube(i,j,*)) & $
endfor

;

rel_speed = fltarr(n_elements(liste))

for k = 0, n_elements(liste)-1 do begin & $
 nefd_pix = nefd_cube(*,*,k) & $
 index = where(goodpix_ima_7339 eq 1 and nefd_pix gt 0.) & $
 id_good = where(nefd_pix(index) lt 0.7, count) & $
 rel_speed(k) = count/(37.*(0.7/0.2)^2) & $
 print, "Subscan: ", k, " Relative speed/SABOCA: ", rel_speed(k) & $ 
endfor

;

nefd_median = fltarr(73,39)


for j = 0, 39-1 do begin & $
 for i = 0, 73-1 do begin & $
  nefd_median(i,j) = median(nefd_cube(i,j,*)) & $
endfor

atv, nefd_median*goodpix_ima_7339

id_pos = where(goodpix_ima_7339 eq 1 and nefd_median gt 0.)		; 1605 valid pixels in 2014 	    ; 1031 valid pixels in 2013
print, median(nefd_median(id_pos))					; 0.588 Jy.s^1/2	    	    ; 0.625 Jy.s^1/2   0.799111
print, min(nefd_median(id_pos))						; 0.365 Jy.s^1/2	    	    ; 0.302 Jy.s^1/2   0.369462 

artemis_rel_speed = total(1./(37.*(nefd_median(id_pos)/0.2)^2))		; 4.896 (2.047)     	    	    ; 3.15	       1.93


id_zero = where(nefd_median eq 0.)
nefd_median(id_zero) = -!values.f_nan

writefits, 'nefd_artemis_jun14.fits', nefd_median*goodpix_ima_7339*1.e3

;  


min_nefd = min(nefd_median(id_pos))
max_nefd = max(nefd_median(id_pos))-0.1/2.


histogram_nefd = histogram(nefd_median(id_pos),min=min_nefd,max=max_nefd,binsize=0.1)

bin_line = min_nefd+findgen(n_elements(histogram_nefd))*0.1 + 0.5*0.1	;  middle point of nefd bin

; print, total(histogram_nefd)						; 1604

plot, bin_line, histogram_nefd


;;;;;
;;;;;




 conv = 1.10005e-05				; conv_planet_31646(15,17)
; restore, '/Users/pandre/kosma/artemis/Calib_partemis/flat_mars_24822_22may09.xdr', /verb		; --> restoring flat_field
; flat_field(0,15) = 1.
;
; init_obs, scan_number= 43090, type = 'map', init_obs_43090_str
; noise_fft_skydip, 43090, sky_noise_str, /nopowermap, /decorrel
;
; init_obs, scan_number= 43042, type = 'map', init_obs_43042_str
; noise_fft_skydip, 43042, sky_noise_str, /nopowermap, /decorrel
;
;;;;; goodpix_ima_3539 = goodpix_ima_3539(Saturn 43011) ;  flat_field_3539 = flat_field_3539(Saturn 43011)
;
; index = where(goodpix_ima_3539 eq 1 and sky_noise_str(0).rms_noise_corr gt 0. and mask_jul13_array3 eq 1)
; index = where(goodpix_ima_3539 eq 1 and sky_noise_str(0).rms_noise_corr gt 0.)
;
; for i = 0, 5 do print, "Power = ", sky_noise_str(i).mean_level_av,"  ", sky_noise_str(i).scanname, "   El = ", sky_noise_str(i).elevatio
; for i = 0, 5 do print, "Median NEFD = ", median((exp(0.8/sin(50*!pi/180.))/sqrt(40.))*sky_noise_str(i).rms_noise_corr/flat_field_3539/conv)
; for i = 0, 5 do print, "Min NEFD = ", min((exp(0.8/sin(50*!pi/180.))/sqrt(40.))*sky_noise_str(i).rms_noise_corr/flat_field_3539/conv)
;
; for i = 0, 5 do print, "Median NEFD = ", median((1/sqrt(40.))*sky_noise_str(i).rms_noise_corr(index)/flat_field_3539(index)/conv)
; for i = 0, 5 do print, "Min NEFD = ", min((1/sqrt(40.))*sky_noise_str(i).rms_noise_corr(index)/flat_field_3539(index)/conv)
;
;;;;;;;;;;;; ind_noi0 = index(where(sky_noise_str(0).rms_noise_corr(index) eq 0.0))
;
; atv, (1/sqrt(40.))*sky_noise_str(0).rms_noise_corr*goodpix_ima_3539/flat_field_3539/conv
;
; help, where((1/sqrt(40.))*sky_noise_str(0).rms_noise_corr(index)*goodpix_ima_3539(index)/flat_field_3539(index)/conv lt 0.7)
;;;;;;
;;;;;;

int_max = fltarr(35,39)
;
for j = 0, 38 do begin & $
for i = 0, 34 do begin & $
int_max(i,j) = max(donnees_red.cube(i,j,*)) & $
endfor

;;;;;;
;;;;;;

toto = mrdfits('/Users/pandre/kosma/artemis/Calib_partemis/ACQ_130718_134057.fits',1)
help, toto, /str
time = (toto.mjd-toto(0).mjd)*24.*3600.d0		; sec traite_otf_map_main, scan_number= 31646, type = 'chmap', planet_ch_map_31646_str, tau=1.03
;
plot, toto(*).data(31,17)
plot, time, toto(*).data(31,17)
;
ind_abs = where(toto(*).data(31,17) gt -0.18)
;
plot, time(ind_abs), toto(ind_abs).data(31,17)

;

print, (1/sqrt(40.))*stdev(toto(ind_abs).data(31,17))/conv


;;;;
;;;;

init_obs, scan_number= 31646, type = 'map', init_obs_31646_str

traite_otf_map_main, scan_number= 31646, type = 'map', mars_otf_31646_str, tau=1.03, /newreduc	;   Peak flux (echant = 5) = 171.263	;   Peak flux (echant = 3) = 165.324   166.65 Jy/beam

image = mars_otf_31646_str.image									;   161.518(154.277) (-)  160.518(152.193) (+)
													;   166.151(157.437) (-)  172.345(165.121) (+)

													;   175.235 (echant 5, norcp but off_arr, base_rad = 25.)

gaussfit = gauss2dfit(image,gaussfit_aparm,/tilt)

print, "Zero Level (Jy/beam) = ", gaussfit_aparm(0)								  ;-0.337791	-0.313395	-0.321853         	   ; -0.374926
print, "Peak Intensity (Jy/beam) = ", gaussfit_aparm(1)								  ;180.886 (off) 180.294  174.870 (no_off) 164.276	 165.318    (echant = 5)   ; 159.420158 (echant = 3)
print, "Delta x  (arcsec) = ", (gaussfit_aparm(4)-mars_otf_31646_str.crpix1)*mars_otf_31646_str.cdelt1*3600.  ;0.61996088	 1.9003158 	 1.8795532   		   ; 0.906266890
print, "Delta y  (arcsec) = ", (gaussfit_aparm(5)-mars_otf_31646_str.crpix2)*mars_otf_31646_str.cdelt2*3600.  ;1.3045690	-0.35568788 	-0.41314501 		   ; 0.80144627
print, "Position angle of major axis measured counterclockwise from x axis (deg) = ", gaussfit_aparm(6)		  ;-0.364940	-0.362511   	-0.359811		   ; -0.374444
print, "Maj FWHM (arcsec) = ", gaussfit_aparm(2)*sqrt(8.*alog(2.))*mars_otf_31646_str.cdelt2*3600.		  ;10.7887	10.9038      	10.6449	     	   	   ; 10.3356
print, "Min FWHM (arcsec) = ", gaussfit_aparm(3)*sqrt(8.*alog(2.))*mars_otf_31646_str.cdelt2*3600.		  ;8.31683	8.48839     	8.31433	     	   	   ; 8.26247


;

;goodpix_ima_saturn_arr2_jul13.xdr
traite_otf_map_main, scan_number = 31646, type = 'map', mars_otf_arr2_31646_str, tau=1.03, /newreduc

image = mars_otf_arr2_31646_str.image																						

gaussfit = gauss2dfit(image,gaussfit_aparm,/tilt)										; flat_saturn_43011_jul13.xdr

print, "Zero Level (Jy/beam) = ", gaussfit_aparm(0)								  		; 0.525462  0.507664		0.412648
print, "Peak Intensity (Jy/beam) = ", gaussfit_aparm(1)								  		; 180.783   174.672    (3.87)	178.952
print, "Delta x  (arcsec) = ", (gaussfit_aparm(4)-mars_otf_arr2_31646_str.crpix1)*mars_otf_arr2_31646_str.cdelt1*3600.  	; 1.6073966		1.2668584
print, "Delta y  (arcsec) = ", (gaussfit_aparm(5)-mars_otf_arr2_31646_str.crpix2)*mars_otf_arr2_31646_str.cdelt2*3600.  	; 0.84970700		0.58194383
print, "Position angle of major axis measured counterclockwise from x axis (deg) = ", gaussfit_aparm(6)		  		; -0.310730		-0.342765
print, "Maj FWHM (arcsec) = ", gaussfit_aparm(2)*sqrt(8.*alog(2.))*mars_otf_arr2_31646_str.cdelt2*3600.		  	; 12.7826		11.3894
print, "Min FWHM (arcsec) = ", gaussfit_aparm(3)*sqrt(8.*alog(2.))*mars_otf_arr2_31646_str.cdelt2*3600.		  	; 8.45464		7.94774

daz_2 = 1.6073966
del_2 = 0.84970700

;;;;;;

;goodpix_ima_saturn_arr3_jul13.xdr
traite_otf_map_main, scan_number = 31646, type = 'map', mars_otf_arr3_31646_str, tau=1.03, /newreduc

image = mars_otf_arr3_31646_str.image																						

gaussfit = gauss2dfit(image,gaussfit_aparm,/tilt)										; flat_saturn_43011_43618_43620_jul13.xdr

print, "Zero Level (Jy/beam) = ", gaussfit_aparm(0)								  		; -0.0328110		-0.144635
print, "Peak Intensity (Jy/beam) = ", gaussfit_aparm(1)								  		; 201.025 (3.87)	199.922
print, "Delta x  (arcsec) = ", (gaussfit_aparm(4)-mars_otf_arr3_31646_str.crpix1)*mars_otf_arr3_31646_str.cdelt1*3600.  	; 0.21720595		1.2383483
print, "Delta y  (arcsec) = ", (gaussfit_aparm(5)-mars_otf_arr3_31646_str.crpix2)*mars_otf_arr3_31646_str.cdelt2*3600.  	;  1.4136962		-0.42360893
print, "Position angle of major axis measured counterclockwise from x axis (deg) = ", gaussfit_aparm(6)		  		; -0.304339		-0.342102
print, "Maj FWHM (arcsec) = ", gaussfit_aparm(2)*sqrt(8.*alog(2.))*mars_otf_arr3_31646_str.cdelt2*3600.		  	; 10.6879		10.0094
print, "Min FWHM (arcsec) = ", gaussfit_aparm(3)*sqrt(8.*alog(2.))*mars_otf_arr3_31646_str.cdelt2*3600.		  	; 8.34954		7.98457

daz_3 = 0.21720595
del_3 = 1.4136962

;;;;;;

;goodpix_ima_saturn_arr6_jul13.xdr
traite_otf_map_main, scan_number = 31646, type = 'map', mars_otf_arr6_31646_str, tau=1.03, /newreduc

image = mars_otf_arr6_31646_str.image												

gaussfit = gauss2dfit(image,gaussfit_aparm,/tilt)										; flat_saturn_43011_43618_43620_jul13.xdr

print, "Zero Level (Jy/beam) = ", gaussfit_aparm(0)								  		; 0.0110872  0.0105370	  0.0623042		 0.0386615
print, "Peak Intensity (Jy/beam) = ", gaussfit_aparm(1)								  		; 170.328  162.217  (3.87) 163.763 (3.83)	 148.143 (3.87)
print, "Delta x  (arcsec) = ", (gaussfit_aparm(4)-mars_otf_arr6_31646_str.crpix1)*mars_otf_arr6_31646_str.cdelt1*3600.  	; 0.78413589	  0.44656612		 0.79356052
print, "Delta y  (arcsec) = ", (gaussfit_aparm(5)-mars_otf_arr6_31646_str.crpix2)*mars_otf_arr6_31646_str.cdelt2*3600.  	; 1.5445661	  1.1386089		 1.5291183
print, "Position angle of major axis measured counterclockwise from x axis (deg) = ", gaussfit_aparm(6)		  		; -0.488714	  -0.336436		 -0.482129
print, "Maj FWHM (arcsec) = ", gaussfit_aparm(2)*sqrt(8.*alog(2.))*mars_otf_arr6_31646_str.cdelt2*3600.		  	; 11.0816	  10.7136		 11.1680 
print, "Min FWHM (arcsec) = ", gaussfit_aparm(3)*sqrt(8.*alog(2.))*mars_otf_arr6_31646_str.cdelt2*3600.		  	; 8.30447	  8.40666		 8.33645 

daz_6 = 0.78413589
del_6 = 1.5445661

;;;;;;

;goodpix_ima_saturn_arr7_jul13.xdr
traite_otf_map_main, scan_number = 31646, type = 'map', mars_otf_arr7_31646_str, tau=1.03, /newreduc

image = mars_otf_arr7_31646_str.image												

gaussfit = gauss2dfit(image,gaussfit_aparm,/tilt)										; flat_saturn_43011_43618_43620_jul13.xdr

print, "Zero Level (Jy/beam) = ", gaussfit_aparm(0)								  		; 0.05182100.0493900		-0.000372577
print, "Peak Intensity (Jy/beam) = ", gaussfit_aparm(1)								  		; 174.296  165.996 (3.87)	159.690
print, "Delta x  (arcsec) = ", (gaussfit_aparm(4)-mars_otf_arr7_31646_str.crpix1)*mars_otf_arr7_31646_str.cdelt1*3600.  	; 0.53013172			2.5610786
print, "Delta y  (arcsec) = ", (gaussfit_aparm(5)-mars_otf_arr7_31646_str.crpix2)*mars_otf_arr7_31646_str.cdelt2*3600.  	; 1.1939360			-0.98600372
print, "Position angle of major axis measured counterclockwise from x axis (deg) = ", gaussfit_aparm(6)		  		; -0.336826			-0.275245
print, "Maj FWHM (arcsec) = ", gaussfit_aparm(2)*sqrt(8.*alog(2.))*mars_otf_arr7_31646_str.cdelt2*3600.		  	; 9.62748			9.27223
print, "Min FWHM (arcsec) = ", gaussfit_aparm(3)*sqrt(8.*alog(2.))*mars_otf_arr7_31646_str.cdelt2*3600.		  	; 7.96254			7.81598

daz_7 = 0.53013172
del_7 = 1.1939360

;;;;;;

daz_3_rel = -1.39019
del_3_rel = 0.563989

daz_6_rel = -0.823261
del_6_rel =  0.694859

daz_7_rel = -1.07726
del_7_rel =  0.344229

;;;;;;


restore, '/Users/pandre/kosma/artemis/apexdata/map_otf_xdr/T-091.F-0008-2013/otf_subscan_31646_50.xdr', /verb

for i = 0, 436 do atv, donnees_red.cube(*,*,i)*init_obs_31646_str.goodpix_ima


mars_otf_norcp_31646_str = mars_otf_31646_str

image = mars_otf_norcp_31646_str.image

gaussfit = gauss2dfit(image,gaussfit_aparm,/tilt)

print, "Zero Level (Jy/beam) = ", gaussfit_aparm(0)										; -0.375580
print, "Peak Intensity (Jy/beam) = ", gaussfit_aparm(1)										; 158.758
print, "Delta x  (arcsec) = ", (gaussfit_aparm(4)-mars_otf_norcp_31646_str.crpix1)*mars_otf_norcp_31646_str.cdelt1*3600.	; 0.94727220
print, "Delta y  (arcsec) = ", (gaussfit_aparm(5)-mars_otf_norcp_31646_str.crpix2)*mars_otf_norcp_31646_str.cdelt2*3600.	; 0.81538925
print, "Position angle of major axis measured counterclockwise from x axis (deg) = ", gaussfit_aparm(6)				;  -0.339212
print, "Maj FWHM (arcsec) = ", gaussfit_aparm(2)*sqrt(8.*alog(2.))*mars_otf_norcp_31646_str.cdelt2*3600.			; 10.2780
print, "Min FWHM (arcsec) = ", gaussfit_aparm(3)*sqrt(8.*alog(2.))*mars_otf_norcp_31646_str.cdelt2*3600.			; 8.33497

;;

init_obs, scan_number= 31646, type = 'map', init_obs_31646_str

traite_otf_map_main, scan_number= 31646, type = 'map', mars_otf_31646_str, tau=1.03, /do_rcp, /newreduc  ; Peak flux=166.3 (echant=3) 166.619 (echant=5, 1.05) 167.742 Jy/beam (echant=5)

mars_otf_rcp_31646_str = mars_otf_31646_str

image = mars_otf_rcp_31646_str.image

gaussfit = gauss2dfit(image,gaussfit_aparm,/tilt)

print, "Zero Level (Jy/beam) = ", gaussfit_aparm(0)										; -0.160538    --> -0.185927	--> -0.173952
print, "Peak Intensity (Jy/beam) = ", gaussfit_aparm(1)										; 157.153      ->    157.316	-->  157.918
print, "Delta x  (arcsec) = ", (gaussfit_aparm(4)-mars_otf_rcp_31646_str.crpix1)*mars_otf_rcp_31646_str.cdelt1*3600.	; 1.4129443    -->   1.3439170	--> 1.3905862
print, "Delta y  (arcsec) = ", (gaussfit_aparm(5)-mars_otf_rcp_31646_str.crpix2)*mars_otf_rcp_31646_str.cdelt2*3600.	; -0.50393659  --> -0.45028035	-->-0.42731066
print, "Position angle of major axis measured counterclockwise from x axis (deg) = ", gaussfit_aparm(6)				; -0.0762457  --> 0.245535	--> 0.323422
print, "Maj FWHM (arcsec) = ", gaussfit_aparm(2)*sqrt(8.*alog(2.))*mars_otf_rcp_31646_str.cdelt2*3600.			; 9.24249     --> 9.20450	--> 9.20172
print, "Min FWHM (arcsec) = ", gaussfit_aparm(3)*sqrt(8.*alog(2.))*mars_otf_rcp_31646_str.cdelt2*3600.			; 9.05963     --> 9.11445	--> 8.95231


;;;;
;;;;

ind_good_7339 = where(goodpix_ima_7339 eq 1)
print, median(donnees_red.rmsmoy(ind_good_7339))

goodpix_ima_noise = mask_jun14

data_list = findfile('/Users/pandre/kosma/artemis/apexdata/map_otf_xdr/T-091.F-0008-2013/otf_subscan_31646_*.xdr',count=nfile)

for i = 0, n_elements(data_list)-1 do begin & $
    print, data_list(i) & restore, data_list(i),/verb & $
    med_rms = median(donnees_red.rmsmoy(ind_good_7339)) & ind_bad = where(donnees_red.rmsmoy eq 0 or donnees_red.rmsmoy gt 10.*med_rms, cnt_bad) & $
    if cnt_bad gt 0 then goodpix_ima_noise(ind_bad) = 0 & $    
endfor

atv, goodpix_ima_noise
atv, goodpix_ima_7339*goodpix_ima_noise

help, where(goodpix_ima_noise)	    	    	    ;   1678
help, where(goodpix_ima_7339)	    	    	    ;   1645
help, where(goodpix_ima_7339*goodpix_ima_noise)     ;   1605	    	1605./2304. = 0.696615
    
