; venus_29807_rcp.pro: "Batch" IDL file 
;
;

; 350 microns focal plane : 64 x 36 = 2304 pixels in ArTeMiS350 but only 32 x 36 = 1152 pixels are used in 2013 and 1/06/2014
n_channel_x = 35      ; including 3 fake pixels between subarrays
n_channel_y = 39      ; including 3 fake pixels between subarrays

npix_eff = 35L*39L    ; including gaps

nx_chan = indgen(n_channel_x)#(transpose(intarr(n_channel_y))+1)
ny_chan = (intarr(n_channel_x)+1)#transpose(indgen(n_channel_y))

mask_jul13 = intarr(n_channel_x,n_channel_y)+1
mask_jul13(16:18,*) = 0
mask_jul13(*,18:20) = 0

mask_jul13_2 = mask_jul13*0
mask_jul13_2(0:15,0:17) = 1

mask_jul13_3 = mask_jul13*0
mask_jul13_3(19:34,0:17) = 1

mask_jul13_6 = mask_jul13*0
mask_jul13_6(0:15,21:38) = 1

mask_jul13_7 = mask_jul13*0
mask_jul13_7(19:34,21:38) = 1

n_jul13 = 4
;
mask_arr_jul13 = intarr(n_channel_x,n_channel_y,n_jul13)
;
mask_arr_jul13(*,*,0) = mask_jul13_2
mask_arr_jul13(*,*,1) = mask_jul13_3
mask_arr_jul13(*,*,2) = mask_jul13_6
mask_arr_jul13(*,*,3) = mask_jul13_7


mask_jul13 = intarr(n_channel_x,n_channel_y)+1
mask_jul13(16:18,*) = 0
mask_jul13(*,18:20) = 0

mask_jul13_2 = mask_jul13*0
mask_jul13_2(0:15,0:17) = 1

mask_jul13_3 = mask_jul13*0
mask_jul13_3(19:34,0:17) = 1

mask_jul13_6 = mask_jul13*0
mask_jul13_6(0:15,21:38) = 1

mask_jul13_7 = mask_jul13*0
mask_jul13_7(19:34,21:38) = 1

n_jul13 = 4
;
mask_arr_jul13 = intarr(n_channel_x,n_channel_y,n_jul13)
;
mask_arr_jul13(*,*,0) = mask_jul13_2
mask_arr_jul13(*,*,1) = mask_jul13_3
mask_arr_jul13(*,*,2) = mask_jul13_6
mask_arr_jul13(*,*,3) = mask_jul13_7

ind_jul13 = where(mask_jul13 gt 0, nchan_eff)					;   1152 pixels

print, nchan_eff  			; Effective number of 350mu bolometer channels in 2013

; nchan_eff = 32*36	   		; Effective number of 350mu bolometer channels in 2013



init_obs, scan_number= 29807, type = 'map', init_obs_29807_str
traite_otf_map_main, scan_number= 29807, type = 'map', venus_29807_str, tau=1.73,/newreduc


;
traite_otf_map_main, scan_number= 29807, type = 'chmap', venus_ch_map_29807_str, tau=1.73,/newreduc
for j = 0, nchan_eff-1 do atv, venus_ch_map_29807_str.ch_map(*,*,j)

venus_29807_gaussfit_apar = fltarr(7,npix_eff)

for j = 0, nchan_eff-1 do begin & i = ind_jul13(j) & $
   print, " Channel (32*36) ", j,  "     Channel (35*39) ", i & $      
   venus_29807_gaussfit = gauss2dfit(venus_ch_map_29807_str.ch_map(*,*,i),gaussfit_apar,/tilt) & $
   venus_29807_gaussfit_apar(*,i) = gaussfit_apar & $
   print, "Zero Level (Jy/beam) = ", venus_29807_gaussfit_apar(0,i) & $
   print, "Peak Intensity (Jy/beam) = ", venus_29807_gaussfit_apar(1,i) & $
   print, "Delta x  (arcsec) = ", (venus_29807_gaussfit_apar(4,i)-venus_ch_map_29807_str.crpix1)*venus_ch_map_29807_str.cdelt1*3600. & $
   print, "Delta y  (arcsec) = ", (venus_29807_gaussfit_apar(5,i)-venus_ch_map_29807_str.crpix2)*venus_ch_map_29807_str.cdelt2*3600. & $
   print, "Position angle of major axis measured counterclockwise from x axis (deg) = ", venus_29807_gaussfit_apar(6,i) & $
   print, "Maj FWHM (arcsec) = ", venus_29807_gaussfit_apar(2,i)*sqrt(8.*alog(2.))*venus_ch_map_29807_str.cdelt2*3600. & $
   print, "Min FWHM (arcsec) = ", venus_29807_gaussfit_apar(3,i)*sqrt(8.*alog(2.))*venus_ch_map_29807_str.cdelt2*3600. & $
   print, "       " & $
endfor


flat_venus_29807 = fltarr(npix_eff)
nx_ref_pix = 15  ;  19						    ; Reference pixel for Calibration (19,21)  Conv = 1.08759e-05
ny_ref_pix = 17  ;  21
;;print, where(nx_chan eq 19 and ny_chan eq 21)	    ; print, where(nx_chan eq 15 and ny_chan eq 17)
; 
n_ref_pix = 754  ;  610							;  pixel de reference dans la matrice ArTeMiS350_2013 (35x39) : (19,21) <--> 754 (IDL) ;  (15,17) <--> 610 (IDL)
;
peak_ref = venus_29807_gaussfit_apar(1,n_ref_pix)			;  Peak intensity in map made with reference bolometer channel
flat_venus_29807(*) = venus_29807_gaussfit_apar(1,*)/peak_ref
flat_venus_29807 = reform(flat_venus_29807,n_channel_x,n_channel_y)
flat_field = flat_venus_29807						;  0.2 -> 10

;

goodpix_ima = fltarr(n_channel_x,n_channel_y)+1.
;ind = where(flat_field lt 0.2 or flat_field gt 5.)
ind = where(flat_field lt 0.5 or flat_field gt 2.)
goodpix_ima(ind) = 0.
goodpix_ima(0,8) = 0
goodpix_ima(10,1) = 0
goodpix_ima(15,2) = 0
goodpix_ima(15,3) = 0
goodpix_ima(15,9) = 0

;

daz_venus = fltarr(n_channel_x,n_channel_y)
del_venus = fltarr(n_channel_x,n_channel_y)

daz_venus(*) = -(venus_29807_gaussfit_apar(4,*)-venus_ch_map_29807_str.crpix1)*venus_ch_map_29807_str.cdelt1*3600.
del_venus(*) = -(venus_29807_gaussfit_apar(5,*)-venus_ch_map_29807_str.crpix2)*venus_ch_map_29807_str.cdelt2*3600.

daz_venus0 = daz_venus(15,17)		     ;  Reference pixel = (15,17) in 35*39 grid
del_venus0 = del_venus(15,17)

daz_venus = daz_venus-daz_venus0
del_venus = del_venus-del_venus0


daz_venus_29807 = daz_venus 
del_venus_29807 = del_venus

dx_venus = -daz_venus				;  Ignoring any rotation
dy_venus = del_venus

atv, dx_venus*goodpix_ima
atv, dy_venus*goodpix_ima


nxchan = indgen(n_channel_x)#(transpose(intarr(n_channel_y))+1)
nychan = (intarr(n_channel_x)+1)#transpose(indgen(n_channel_y))

pix = 3.8
alpha = 0.

;; All 4 sub-arrays

index = where(goodpix_ima eq 1)
;;;;;index = where(goodpix_ima_3539 eq 1)

dpos_venus  = [dx_venus(index),dy_venus(index)]
;;;;;;;;dpos_venus  = [-dx_venus(index),dy_venus(index)]
dchan   = [(nxchan-nx_ref_pix)(index),(nychan-ny_ref_pix)(index)]
dchan_t = [(nychan-ny_ref_pix)(index),-(nxchan-nx_ref_pix)(index)]

;

dchan_var = float([dchan,dchan_t])		;  Vector of "independent variables"
dpos_var  = dpos_venus				;  Vector of "dependent variables"

chi_red = 0.
apar = [pix, alpha]
rms = apar*0.
weights = dpos_var*0.+1.
;
.run rcp_fun
rcp_fit = CURVEFIT(dchan_var,dpos_var,Weights,APAR,RMS,CHISQ=chi_red,FUNCTION_NAME='rcp_fun')
;
print, "Pixel size (arcsec) : ", apar(0), " +- ", rms(0)						;   3.65125 +-    0.00143892
print, "Rotation angle of the array (deg) : ", apar(1)*180./!pi," +- ", rms(1)*180./!pi			;  -12.4406 +-     0.0231058


;

chi_red = 0.
xpos0 = 0.
ypos0 = 0.
apar = [pix, alpha, xpos0, ypos0]
rms = apar*0.
weights = dpos_var*0.+1.
;
rcp_fit = CURVEFIT(dchan_var,dpos_var,Weights,APAR,RMS,CHISQ=chi_red,FUNCTION_NAME='rcp_fun_off')
;
print, "Pixel size (arcsec) : ", apar(0), " +- ", rms(0)					 	;  3.66949 +-    0.00209350
print, "Rotation angle of the array (deg) : ", apar(1)*180./!pi," +- ", rms(1)*180./!pi		 	; -12.3185 +-     0.0333829
print, "X_offset (arcsec) : ", apar(2), " +- ", rms(2)						 	; -1.18040 +-     0.0324801
print, "Y_offset (arcsec) : ", apar(3), " +- ", rms(3)						 	; -1.55928 +-     0.0324801

;

chi_red = 0.
xpos0 = 0.
ypos0 = 0.
apar = [pix, alpha, xpos0, ypos0]
rms = apar*0.
weights = dpos_var*0.+1.
;
.r rcp_fun_gen_off
rcp_fit = CURVEFIT(dchan_var,dpos_var,Weights,APAR,RMS,CHISQ=chi_red,FUNCTION_NAME='rcp_fun_gen_off')
;
print, "Pixel size (arcsec) : ", apar(0), " +- ", rms(0)						; 3.75334 +-    0.00199233
print, "Rotation angle of the array (deg) : ", apar(1)*180./!pi," +- ", rms(1)*180./!pi			; -12.1343 +-     0.0304138
print, "X_offset (arcsec) : ", apar(2), " +- ", rms(2)							; -1.18032 +-     0.0309103
print, "Y_offset (arcsec) : ", apar(3), " +- ", rms(3)							; -1.55928 +-     0.0309103

;

artemis350_dazdel2dxdy, daz_venus, del_venus, dx_venus_rot, dy_venus_rot

dx_venus_29807 = dx_venus_rot
dy_venus_29807 = dy_venus_rot

atv, dx_venus_29807*goodpix_ima
atv, dy_venus_29807*goodpix_ima

dx_venus = dx_venus_rot
dy_venus = dy_venus_rot

;

dx_rcp = dx_venus_29807
dy_rcp = dy_venus_29807


nxchan = indgen(n_channel_x)#(transpose(intarr(n_channel_y))+1)
nychan = (intarr(n_channel_x)+1)#transpose(indgen(n_channel_y))

pix = 3.87
alpha = 0.

index = where(goodpix_ima eq 1)

dpos_venus  = [dx_venus(index),dy_venus(index)]
;;;;;;;dpos_venus  = [-dx_venus(index),dy_venus(index)]
dchan   = [(nxchan-nx_ref_pix)(index),(nychan-ny_ref_pix)(index)]
dchan_t = [(nychan-ny_ref_pix)(index),-(nxchan-nx_ref_pix)(index)]


print, "Simple estimate of the pixel size (arcsec) : ", correlate(dchan,dpos_venus,/covariance)/(sigma(dchan))^2	   ; Simple estimate of the pixel size (arcsec): 3.75390

;

dchan_var = float([dchan,dchan_t])		;  Vector of "independent variables"
dpos_var  = dpos_venus				;  Vector of "dependent variables"

chi_red = 0.
apar = [pix, alpha]
rms = apar*0.
weights = dpos_var*0.+1.
;
.run rcp_fun
;rcp_fit = LMFIT(dchan_var,dpos_var,APAR,SIGMA=RMS,CHISQ=chi,FUNCTION_NAME='rcp_fun')
rcp_fit = CURVEFIT(dchan_var,dpos_var,Weights,APAR,RMS,CHISQ=chi_red,FUNCTION_NAME='rcp_fun')
;
print, "Pixel size (arcsec) : ", apar(0), " +- ", rms(0)								   ; 3.73345 +-    0.00207050  	  arcsec
print, "Rotation angle of the array (deg) : ", apar(1)*180./!pi," +- ", rms(1)*180./!pi		 			   ; -2.00644 +-   0.0318373 	  deg

;

chi_red = 0.
xpos0 = 0.
ypos0 = 0.
apar = [pix, alpha, xpos0, ypos0]
rms = apar*0.
weights = dpos_var*0.+1.
;
rcp_fit = CURVEFIT(dchan_var,dpos_var,Weights,APAR,RMS,CHISQ=chi_red,FUNCTION_NAME='rcp_fun_off')
;
print, "Pixel size (arcsec) : ", apar(0), " +- ", rms(0)						; 3.75708 +-    0.00209997
print, "Rotation angle of the array (deg) : ", apar(1)*180./!pi," +- ", rms(1)*180./!pi			; -1.84977 +-     0.0320412
print, "X_offset (arcsec) : ", apar(2), " +- ", rms(2)							; -1.66288 +-     0.0325895
print, "Y_offset (arcsec) : ", apar(3), " +- ", rms(3)							; -1.26564 +-     0.0325895

